      SUBROUTINE ALLRED(
     >                  MYRANK,NROFNODES,
     >                  LSMPIC,LSMYRANK,
     >                  GLLKE1_LOC,
     <                  GLLKE1)
C ======================================================================
C                       build MPI_Groups 
C ======================================================================
C
C this routine preforms an MPI_ALLREDUCE command for
C a given set of ranks
C
C                               Alexander Thiess, 7th of December 2009
C =======================================================================
C
      IMPLICIT NONE
C
      include 'mpif.h'
C     .. Parameters ..
      include 'inc.p'
C 
      INTEGER   LMMAXD
      PARAMETER (LMMAXD= (LMAXD+1)**2)
      INTEGER   ALM
      PARAMETER (ALM = NAEZD*LMMAXD)
C
C     .. global arrays ..
      DOUBLE COMPLEX GLLKE1_LOC(ALM,LMMAXD),GLLKE1(ALM,LMMAXD)
C     .. local scalars ..
      INTEGER        LM1,LM2,ILM,SEND,RECV,L,LMPI
      LOGICAL        CMMNC
C     .. local arrays ..
      DOUBLE COMPLEX GSEND(ALM),GRECV(ALM)
      INTEGER        RECVRANKS(LMMAXD)
C
C     .. MPI ..
      INTEGER, dimension(MPI_STATUS_SIZE) :: STATUS
      INTEGER        IERR,MAPBLOCK
C     .. N-MPI
      INTEGER        MYRANK,NROFNODES
C     .. LS-MPI
      INTEGER        LSMYRANK(LMPID,NAEZD*SMPID*EMPID),
     +               LSMPI,LSMPIC
C
C       1st outer loop: definition of SEND-rank and position in
C       G-matrix
C
        DO LM1=1,LMMAXD
C
          SEND = LSMYRANK(MAPBLOCK(LM1,1,LMMAXD,1,0,LMPID-1)+1,LSMPIC)
C
          IF (MYRANK.EQ.SEND) THEN
C
            DO ILM=1,ALM
              GSEND(ILM)=GLLKE1_LOC(ILM,LM1)
            ENDDO
C
          ENDIF
C
C       2nd outer loop: definition of RECV-rank
C
          DO L=1,LMMAXD
          RECVRANKS(L) = -2
          ENDDO
          LMPI=1
C
          DO LM2=1,LMMAXD
C
            RECV=LSMYRANK(MAPBLOCK(LM2,1,LMMAXD,1,0,LMPID-1)+1,LSMPIC)
C
C           test if communication is required
C
            CMMNC = .TRUE.
            DO L=1,LMMAXD
              IF (RECVRANKS(L).EQ.RECV) CMMNC = .FALSE.
            ENDDO
C
            RECVRANKS(LMPI) = RECV
            LMPI = LMPI+1
C
            IF (CMMNC) THEN
C
              IF (RECV.EQ.SEND.AND.RECV.EQ.MYRANK) THEN
                DO ILM=1,ALM
                  GLLKE1(ILM,LM1)=GLLKE1_LOC(ILM,LM1)
                ENDDO
              ELSE
C
C  MPI_SEND array from SEND and MPI_RECV at RECV
C
              IF (MYRANK.EQ.SEND) THEN
C
                CALL MPI_SEND(GSEND,ALM,MPI_DOUBLE_COMPLEX,
     +                        RECV,98,MPI_COMM_WORLD,IERR)
C
              ENDIF
C
              IF (MYRANK.EQ.RECV) THEN

                CALL MPI_RECV(GRECV,ALM,MPI_DOUBLE_COMPLEX,
     +                        SEND,98,MPI_COMM_WORLD,STATUS,IERR)
C
                DO ILM=1,ALM
                  GLLKE1(ILM,LM1)=GRECV(ILM)
                ENDDO
C
              ENDIF
C
              ENDIF
C
            ENDIF
C
C  finished communication for pair of LM1,LM2
C
          ENDDO
C
        ENDDO
C
      RETURN
C
      END
