C***********************************************************************
C*********   EXTRAPOL  *************************************************
C***********************************************************************

      SUBROUTINE EXTRAPOL(
     >                    PREXK,EZ,IE,KMESH,
     <                    GLLKE0)

      IMPLICIT NONE

C     .. Parameters ..
      include 'inc.p'
      INTEGER          LMMAXD
      PARAMETER        (LMMAXD= (LMAXD+1)**2)
      DOUBLE COMPLEX   CZERO
      PARAMETER        (CZERO= ( 0.0D0,0.0D0 ))
C     Global arrays ..
      DOUBLE COMPLEX   GLLKE0(NPRECD,LMMAXD)
      DOUBLE COMPLEX   EZ(IEMXD)
      COMPLEX          PREXK(NPREXD,LMMAXD,3)
      INTEGER          KMESH(IEMXD)
C     Global scalars ..
      INTEGER          IE
C     Local arrays ..
      COMPLEX          A,B,C 
      DOUBLE PRECISION E(IEMXD)
C     Local scalars ..
      DOUBLE PRECISION E3112,E12,E23,E_DENOM
      INTEGER          I1,ILM,LM1,LM2
      LOGICAL          COPYIT,LINEAR,QUADR 
C     Intrinsic functions ..
      INTRINSIC        DBLE, DCMPLX
C
C
C
      COPYIT = .false.
      LINEAR = .false.
      QUADR  = .false.
C
C first set precondioned matrix equal zero
C
      DO I1=1, NAEZD
        DO LM1=1, LMMAXD 
          ILM=LMMAXD*(I1-1)+LM1
          DO LM2=1, LMMAXD 
           GLLKE0(ILM,LM2) = CZERO
          ENDDO 
        ENDDO 
      ENDDO
C
C only extrapolate if KMESH(IE) = KMESH(IE-1)
C
      IF (KMESH(IE).EQ.KMESH(IE-1).AND.IE.GT.1) COPYIT = .true.
C
C only extrapolate linear if KMESH(IE) = KMESH(IE-1) = KMESH(IE-2)
C
        IF (COPYIT.AND.KMESH(IE).EQ.KMESH(IE-2).AND.IE.GT.2) THEN

          IF ((DIMAG(EZ(IE-1)).EQ.DIMAG(EZ(IE-2))).AND.
     +      (DIMAG(EZ(IE)).EQ.DIMAG(EZ(IE-1)))) THEN
            LINEAR = .true.
            COPYIT = .false.
            CALL DCOPY(IEMXD,DREAL(EZ),1,E,1)
          ENDIF
C..
          IF ((DREAL(EZ(IE-1)).EQ.DREAL(EZ(IE-2))).AND.
     +      (DREAL(EZ(IE)).EQ.DREAL(EZ(IE-1)))) THEN
            LINEAR = .true.
            COPYIT = .false.
            CALL DCOPY(IEMXD,DIMAG(EZ),1,E,1)
          ENDIF

        ENDIF
C
        IF (LINEAR.AND.KMESH(IE).EQ.KMESH(IE-3)) THEN
          IF (DIMAG(EZ(IE-2)).EQ.DIMAG(EZ(IE-3))) QUADR = .true.
          IF (DREAL(EZ(IE-2)).EQ.DREAL(EZ(IE-3))) QUADR = .true.
        ENDIF
C
        IF (QUADR)  LINEAR = .false.
C----------------------------------------------------------------------
C----------------------------------------------------------------------
      IF (LINEAR) THEN
C----------------------------------------------------------------------
C      this is a linear fit for IE on the basis of the two last points
C      IE-1 and IE-2, It's either performed on the real or imaginary 
C      axis.
C                       G0 = G1 + (G1-G2)*(E3-E1)/(E1-E2)
C      G0 = GLLKE0
C      G1 = PREXK(:,:,2)  
C      G2 = PREXK(:,:,3)
C      E1 = E(IE-2) 
C      E2 = E(IE-1) 
C      E3 = E(IE) 
C                                                       A.THIESS 8/2008
C----------------------------------------------------------------------

        E3112=(E(IE)-E(IE-1))/(E(IE-2)-E(IE-1))

        DO ILM=1, NPREXD
          DO LM2=1, LMMAXD 
            GLLKE0(ILM,LM2) = PREXK(ILM,LM2,3)+
     +      (PREXK(ILM,LM2,3)-PREXK(ILM,LM2,2))*E3112
          ENDDO 
        ENDDO 

C----------------------------------------------------------------------
      ELSEIF (QUADR) THEN
C----------------------------------------------------------------------
C     G0 = A*E4^2 + B*E4 + C
C----------------------------------------------------------------------

        E12=E(IE-3)-E(IE-2)
        E23=E(IE-2)-E(IE-1)
        E_DENOM=(E(IE-3)**2-E(IE-2)**2)/E12-(E(IE-2)**2-E(IE-1)**2)/E23

        DO ILM=1, NPREXD
          DO LM2=1, LMMAXD

        A = ((PREXK(ILM,LM2,1) - PREXK(ILM,LM2,2))/E12
     +    - (PREXK(ILM,LM2,2) - PREXK(ILM,LM2,3))/E23)/E_DENOM

        B = (PREXK(ILM,LM2,1) - PREXK(ILM,LM2,2))/E12
     +    - A*(E(IE-2)**2-E(IE-1)**2)/E23

        C = PREXK(ILM,LM2,3) - A*E(IE-1)**2 - B*E(IE-1)

        GLLKE0(ILM,LM2) = A*E(IE)**2 + B*E(IE) + C
C
         ENDDO
        ENDDO

C----------------------------------------------------------------------
      ELSEIF (COPYIT) THEN
C----------------------------------------------------------------------
C     if no information on linear or quadratic extrapolation is 
C     availible (Starting points of NPT2, NPT3 ) the starting
C     point is G(IE-1)
C----------------------------------------------------------------------

        DO ILM=1, NPREXD
          DO LM2=1, LMMAXD
            GLLKE0(ILM,LM2) =
     +      DCMPLX(REAL(PREXK(ILM,LM2,3)),AIMAG(PREXK(ILM,LM2,3)))
         ENDDO
        ENDDO

C----------------------------------------------------------------------
      ENDIF
C----------------------------------------------------------------------
C     in case no information on previous matrices is availible
C     for this energy point GLLKE0 is set to (0.0D0,0.0D0)
C----------------------------------------------------------------------

      END
