      SUBROUTINE GFMASK(LINTERFACE,ICHECK,ICC,INVMOD,NSH1,NSH2,NAEZ,
     &                  NSHELL)
C **********************************************************************
C *                                                                    *
C * This subroutine prepares the ICHECK matrix that is used for        *
C * calculating the proper off-diagonal GF matrix elements for impurity*
C * or transport calculations in case of no full inversion algorithm   *
C *                                                                    *
C * ICHECK(I,J) points to the block (I,J) of the GF matrix having the  *
C * size NPRINCD                                                       *
C *                                                                    *
C *                                            29.02.2000              *
C *                                                                    *
C **********************************************************************
      IMPLICIT NONE
      INCLUDE 'inc.p'
C     ..
C     .. Scalar arguments
      INTEGER ICC,INVMOD,NLAYER,NAEZ,NSHELL
      LOGICAL LINTERFACE
C     ..
C     .. Array arguments
      INTEGER ICHECK(NAEZD/NPRINCD,NAEZD/NPRINCD)    
      INTEGER NSH1(*),NSH2(*)
C     .. Local variables
      INTEGER ICOUPLE(NAEZD,NAEZD)
      INTEGER I,J,K,II,ISTEP1,ILT1,ISTEP2,ILT2,IL2,IL1,LFCHK
      CHARACTER*80 FMTCHK
      CHARACTER*35 INVALG(0:2)
C     ..
C     .. External functions
      LOGICAL OPT,TEST
      EXTERNAL OPT,TEST
C     ..
C     .. Data statements
      DATA INVALG /'FULL MATRIX                        ',
     &             'BANDED MATRIX (slab)               ',
     &             'BANDED + CORNERS MATRIX (supercell)' /

      WRITE (6,99000)
C
C --> set default inversion to SUPERCELL mode = banded matrix + corners
C
      INVMOD = 2
C
C --> LINTERFACE = use band diagonal mode
C
      IF (LINTERFACE) INVMOD = 1
C
C --> full inversion is performed ONLY BY EXPLICIT request
C
      IF ( OPT('full inv') )  INVMOD = 0
C         
      WRITE (6,99001) INVALG(INVMOD)
C
      NLAYER=NAEZ/NPRINCD  
C ----------------------------------------------------------- INVMOD = 1
C                                                   band-diagonal matrix
      IF (INVMOD.EQ.1) THEN
         DO I=1,NLAYER
            DO J=1,NLAYER
               IF (I.EQ.J) THEN
                  ICHECK(I,J)=1
               ELSE
                  ICHECK(I,J)=0
               ENDIF
            ENDDO
         ENDDO
      ENDIF
C ----------------------------------------------------------- INVMOD = 2
C              band-diagonal matrix with corners (slab periodic along z)
      IF (INVMOD.EQ.2) THEN
         DO I=1,NLAYER
            DO J=1,NLAYER
               IF ( ( I.EQ.J ).OR. ( J.EQ.NLAYER ) 
     &                        .OR. ( I.EQ.NLAYER ) ) THEN
                  ICHECK(I,J)=1
               ELSE
                  ICHECK(I,J)=0
               ENDIF
            ENDDO
         ENDDO
      ENDIF                     
C ================================================= INVMOD = 1, ICC <> 0
C                   band-diagonal matrix, off-diagonal G elements needed
C
C --> prepare the matrix ICOUPLE which has 1 in all nn' blocks 
C     (atomic sites) that are needed
C
C ======================================================================
      IF ( ( ICC.NE.0 ) .AND. ( INVMOD.EQ.1 ) ) THEN
         DO I=1,NAEZ
            DO J=1,NAEZ
               ICOUPLE(I,J) = 0
C
               DO II=1,NSHELL
                  IF ( ( ( NSH1(II).EQ.I ) .AND. ( NSH2(II).EQ.J ) ) 
     &            .OR. ( ( NSH1(II).EQ.J ) .AND. ( NSH2(II).EQ.I ) )
     &                 ) ICOUPLE(I,J) = 1 
               ENDDO
            ENDDO
         ENDDO
C
C ----------------------------------------------------------------------
C Now given the matrix ICOUPLE prepare the matrix ICHECK which has 1 in
C all principal-layer blocks that we need -- this will be used in the 
C matrix inversion
C ----------------------------------------------------------------------
         ISTEP1=0
         ILT1=1
C ----------------------------------------------------------------------
         DO IL1=1,NAEZ
            ISTEP1=ISTEP1+1
C
            IF ( ISTEP1.GT.NPRINCD ) THEN
               ILT1=ILT1+1
               ISTEP1=1
            ENDIF
C
            ILT2=1
            ISTEP2=0
C ......................................................................
            DO IL2=1,NAEZ 
               ISTEP2=ISTEP2+1
C
               IF ( ISTEP2.GT.NPRINCD ) THEN
                  ILT2=ILT2+1
                  ISTEP2=1
               ENDIF
C
               IF ( ICOUPLE(IL1,IL2).EQ.1 ) ICHECK(ILT1,ILT2)=1 
            END DO
C ......................................................................
         END DO
C ----------------------------------------------------------------------
C in the case of calculation of single blocks it has to put the correct 
C value to ICHECK in order to calculate all the elements also necessary 
C to calculate that single block          ?????
C ----------------------------------------------------------------------
         DO J=1,NLAYER
C
C --> loop over the element ICHECK(I,J) with fixed J and I < J
C
            IF (J.NE.1) THEN
               DO I=1,J-1
                  IF (ICHECK(I,J).EQ.1) THEN
                     DO K=I+1,J
                        ICHECK(K,J)=1
                     ENDDO
                     DO K=J,NLAYER
                        ICHECK(K,K)=1
                     END DO
                  ENDIF
               ENDDO
            ENDIF
C
C --> loop over the element ICHECK(I,J) with fixed J and I > J
C
            IF (J.NE.NLAYER) THEN
                DO I=NLAYER,J+1,-1
                    IF (ICHECK(I,J).EQ.1) THEN
                        DO K=I-1,J,-1
                            ICHECK(K,J)=1
                        ENDDO
                    ENDIF
                ENDDO
            ENDIF
        ENDDO
C ----------------------------------------------------------------------
      ENDIF      
C ======================================================================
C
      IF ( TEST('ICHECK  ') ) THEN 
C
         FMTCHK=' '
         LFCHK = 1
         DO I=1,NLAYER
            FMTCHK=FMTCHK(1:LFCHK)//'--'
            LFCHK = LFCHK+2
         END DO
C
         WRITE (6,'(8X,A,/,8X,A)') 'ICHECK matrix :',FMTCHK(1:LFCHK)
         DO I=1,NLAYER
            WRITE (6,'(9X,30I2)') (ICHECK(I,J),J=1,NLAYER)
         ENDDO
         WRITE (6,'(8X,A,/)') FMTCHK(1:LFCHK)
      END IF
      WRITE (6,'(79(1H=),/)')
C
99000 FORMAT (5X,'< GFMASK > : set KKR matrix inversion algorithm',/)
99001 FORMAT (8X,'INVERSION algorithm used : ',A35,/)
      END
