C***********************************************************************
C*********    INVIT    *************************************************
C***********************************************************************

      SUBROUTINE INVIT(TGM1,X2,TMATLL,NUMN0,INDN0,
     +                 IAT,IE,IELAST,ITER,K,LM2,ITCOUNT,RABS1,
     +                 PR,TTLL,
     +                 QMRBOUND)
      IMPLICIT NONE
C     .. Parameters ..
      include 'inc.p'
      include 'inc.cls'

CEPIK#ifdef EPIK
CEPIK#include "epik_user.inc"
CEPIK#else
C     .. dummies ..
CEPIK#define EPIK_USER_REG(n,str)
CEPIK#define EPIK_USER_START(n)
CEPIK#define EPIK_USER_END(n)
CEPIK#endif


      DOUBLE COMPLEX CONE,CZERO
      INTEGER LMMAXD
      PARAMETER (LMMAXD= (LMAXD+1)**2)
      INTEGER NDIM,NAEZ
      PARAMETER (NAEZ=NAEZD,NDIM=NAEZ*LMMAXD)
      INTEGER NGTBD
      PARAMETER (NGTBD = NACLSD*LMMAXD)
      PARAMETER (CONE=(1.0D0,0.0D0),CZERO=(0.0D0,0.0D0))
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION QMRBOUND,RABS1,RABS2,R0INVIT,DZNRM2
      INTEGER I,IT,ITC,IE,IELAST,ITER,K
      INTEGER I1,LM1,LM2,IL1,IL1B,IL2,ITCOUNT,IAT
      INTEGER I3,I2,IL3,LM3,J,IA1,ITCLAST,ITLAST,I2H,I3H,DIMVEC
      INTEGER NUMN0(NAEZD),INDN0(NAEZD,NACLSD)
C     ..
C     .. Local Arrays ..
      DOUBLE COMPLEX  TMATLL(LMMAXD,LMMAXD,NAEZD)
      DOUBLE COMPLEX  TTLL(LMMAXD*NAEZD,LMMAXD)
      DOUBLE COMPLEX  X2(NDIM),
     +                TGM1(LMMAXD,NGTBD,NAEZD),
     +                XH(NGTBD)
      DOUBLE COMPLEX  X0(NDIM),X1(NDIM)
      LOGICAL*1 IB(NAEZD,4)
      LOGICAL TEST,PR
      DOUBLE COMPLEX VECS(NDIM,9)
      DOUBLE PRECISION TOL
      INTEGER INFOTFX(4),NLIM,REVCOM,COLX,COLB
C     ..
C     .. External Subroutines ..
      EXTERNAL ZGEMM,DZNRM2

CEPIK      EPIK_USER_REG(r_innerloop,"<<inner loop>>")
CEPIK      EPIK_USER_REG(r_zgemv,"<<zgemv>>")

C     ..
      INFOTFX(1)=050000
C
C
      DO I = 1,NDIM
        X0(I) = 0.0D0
        X1(I) = 0.0D0
      END DO
C
      IF (PR) THEN
        DO I=1,NAEZ 
          DO LM1=1,LMMAXD
            IL1=LMMAXD*(I-1)+LM1
            X0(IL1)=-TTLL(IL1,LM2)
          ENDDO
        ENDDO
      ELSE
        DO LM1=1,LMMAXD
          IL1=LMMAXD*(IAT-1)+LM1
          X0(IL1)=-TMATLL(LM1,LM2,IAT)
        ENDDO
      ENDIF
C
      ITCOUNT = 0
C
C---------------------------------------
C
      DO I = 1,NDIM
        VECS(I,2) = - X0(I)
      END DO
C
      TOL=QMRBOUND
C
      IF (PR) THEN
        R0INVIT = DZNRM2(NDIM,VECS(1,2),1)
        TOL=QMRBOUND/R0INVIT
      ENDIF
c     IF(IE.EQ.IELAST) TOL = 50.D0*TOL
C
C
      INFOTFX(2) = 0
C
      NLIM = 2500
C
C================================================================
C           iterative cycle begins here (see GO TO 10 below)
C================================================================
C
 10   CONTINUE
C
        CALL ZUTFX (NDIM,NDIM,NLIM,VECS,TOL,INFOTFX,
     >              IE,K,LM2,IAT,ITCOUNT)
C
        REVCOM = INFOTFX(2)
        COLX = INFOTFX(3)
        COLB = INFOTFX(4)
C
C================================================================
C           if not converged REVCOM.EQ.1 ... proceed ...
C================================================================
C
        IF(REVCOM.EQ.1) THEN
C
          DO I = 1,NDIM
            VECS(I,COLB) = - VECS(I,COLX)
          END DO
C
C
C
CEPIK            EPIK_USER_START(r_innerloop)
C
          DO I1=1,NAEZ
C
            DO I2=1,NUMN0(IAT)
              I3=INDN0(I1,I2)
              I3H = (I3-1)*LMMAXD + 1
              I2H = (I2-1)*LMMAXD + 1
              CALL ZCOPY(LMMAXD,VECS(I3H,COLX),1,XH(I2H),1)
            ENDDO
C
            IL1B=LMMAXD*(I1-1)
CEPIK              EPIK_USER_START(r_zgemv)

            CALL ZGEMV('N',LMMAXD,NUMN0(IAT)*LMMAXD,CONE,TGM1(1,1,I1),
     +                 LMMAXD,XH,1,CONE,VECS(IL1B+1,COLB),1)

C              CALL ZGEMV_OPT(LMMAXD,NUMN0(IAT)*LMMAXD,TGM1(1,1,I1),
C     +                       XH,VECS(IL1B+1,COLB))

CEPIK              EPIK_USER_END(r_zgemv)

          ENDDO

CEPIK            EPIK_USER_END(r_innerloop)


          ITCOUNT = ITCOUNT + 1

      GO TO 10
C================================================================
C          iterative cycle ends here ... back to 10
C          if converged REVCOM.NE.1 leave cycle via ENDIF below
C================================================================

        ENDIF

C================================================================
C          solution converged: final copy result back to kkrmat01 
C================================================================

      RABS1=TOL

      CALL ZCOPY(NDIM,VECS(1,1),1,X0,1)
CAND  ENDIF
C
      CALL ZCOPY(NDIM,X0,1,X2,1)
c     WRITE(6,*) 'IE,K,RABS1',IE,K,RABS1


 9000 FORMAT (D20.6,3I5,I10,D10.3)
 9010 FORMAT (D20.9,3I5,I10)
 9020 FORMAT (D20.9,3I5,I10,1P,D10.3)

      END
