C***********************************************************************
C*********    INVIT    *************************************************
C***********************************************************************

      SUBROUTINE MMINVIT(TGM1,X2,TMATLL,NUMN0,INDN0,
     +                   IAT,IE,ITER,KPT,ITCOUNT,
     +                   PR,TTLL,IELAST,
     +                   QMRBOUND)
      IMPLICIT NONE
C     .. Parameters ..
      include 'inc.p'
      include 'inc.cls'

CEPIK#ifdef EPIK
CEPIK#include "epik_user.inc"
CEPIK#else
C     .. dummies ..
CEPIK#define EPIK_USER_REG(n,str)
CEPIK#define EPIK_USER_START(n)
CEPIK#define EPIK_USER_END(n)
CEPIK#endif

      INTEGER        LMMAXD
      PARAMETER     (LMMAXD= (LMAXD+1)**2)
      INTEGER        NDIM,NAEZ
      PARAMETER     (NAEZ=NAEZD,NDIM=NAEZ*LMMAXD)
      INTEGER        NGTBD
      PARAMETER     (NGTBD = NACLSD*LMMAXD)
      DOUBLE COMPLEX CONE,CZERO
      PARAMETER     (CONE=(1.0D0,0.0D0),CZERO=(0.0D0,0.0D0))
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION QMRBOUND,MAXR0,R0INVIT,DZNRM2,TOL
      INTEGER          I,IT,ITC,DIMVEC
      INTEGER          I1,LM1,LM2,IL1,IL1B,IL2,MMCOLB
      INTEGER          I3,I2,IL3,LM3,J,IA1,ITCLAST,ITLAST,I2H,I3H
#ifndef FPP_OMP
      INTEGER          MYTHRD,OMP_GET_THREAD_NUM
#endif
C     ... Global Scalars ..
      INTEGER          IAT,IE,IELAST,ITER,KPT,ITCOUNT
C     ... Global Arrays ..
      DOUBLE COMPLEX   TMATLL(LMMAXD,LMMAXD,NAEZD),
     +                 TTLL(LMMAXD*NAEZD,LMMAXD),
     +                 X2(NDIM,LMMAXD),
     +                 TGM1(LMMAXD,NGTBD,NAEZD)
      INTEGER          NUMN0(NAEZD),INDN0(NAEZD,NACLSD)

C .. for mmzutfx
      INTEGER IERR(LMMAXD),N(LMMAXD),RETLBLLM(LMMAXD),TF(LMMAXD),
     +        TRES(LMMAXD),VF(LMMAXD)
      DOUBLE COMPLEX ALPHA(LMMAXD),BETA(LMMAXD),ETA(LMMAXD),RHO(LMMAXD) 
      DOUBLE PRECISION COS(LMMAXD),VAR(LMMAXD),R0(LMMAXD),RESN(LMMAXD),
     +        TAU(LMMAXD),UCHK(LMMAXD),UNRM(LMMAXD) 
C     ..
C     .. Local Arrays ..
      DOUBLE COMPLEX   X0(NDIM,LMMAXD),
     +                 XH(NGTBD,LMMAXD),
     +                 VECSN(NDIM,9),
     +                 VECS(NDIM,LMMAXD,9)
      LOGICAL*1        IB(NAEZD,4)
      LOGICAL TEST,VECOUT(LMMAXD),VECDONE(LMMAXD),PR
      INTEGER INFOTFX(4,LMMAXD),NLIM(LMMAXD),REVCOM(LMMAXD),REVCOMN,
     &        COLX(LMMAXD),COLB(LMMAXD),INFOCORE(4)
C     ..
C     .. External Subroutines ..
      EXTERNAL ZGEMM,DZNRM2

CEPIK      EPIK_USER_REG(r_innerloop,"<<inner loop>>")
CEPIK      EPIK_USER_REG(r_zgemv,"<<zgemv>>")
C
C
      DO LM2=1,LMMAXD
        INFOTFX(1,LM2)=050000
        RETLBLLM(LM2)=0
        IERR(LM2)=0
        N(LM2)=0
        NLIM(LM2)=1000
        TF(LM2)=0
        TRES(LM2)=0
        VF(LM2)=0
        ALPHA(LM2)=CZERO
        BETA(LM2)=CZERO
        ETA(LM2)=CZERO
        RHO(LM2)=CZERO
        COS(LM2)=0.0D0
        VAR(LM2)=0.0D0
        R0(LM2)=0.0D0
        RESN(LM2)=0.0D0
        TAU(LM2)=0.0D0
        UCHK(LM2)=0.0D0
        UNRM(LM2)=0.0D0 
        VECOUT(LM2)=.FALSE.
        VECDONE(LM2)=.FALSE.
      ENDDO
C
C
      DO I = 1,NDIM
        DO LM2=1,LMMAXD
          X0(I,LM2) = 0.0D0
        END DO
      END DO
C
C-----------------------------------------------------------------------
C intitialize X0 begin
C-----------------------------------------------------------------------
C
      IF (PR) THEN
        DO I=1,NAEZ 
          DO LM1=1,LMMAXD
            IL1=LMMAXD*(I-1)+LM1
            DO LM2=1,LMMAXD
              X0(IL1,LM2)=-TTLL(IL1,LM2)
            ENDDO
          ENDDO
        ENDDO
      ELSE
        DO LM1=1,LMMAXD
          IL1=LMMAXD*(IAT-1)+LM1
          DO LM2=1,LMMAXD
            X0(IL1,LM2)=-TMATLL(LM1,LM2,IAT)
          ENDDO
        ENDDO
      ENDIF
C
C-----------------------------------------------------------------------
C intitialize X0 end
C-----------------------------------------------------------------------
C
C
C
C
      ITCOUNT = 0
C
C
      DO I = 1,NDIM
        DO LM2=1,LMMAXD
          VECS(I,LM2,2) = - X0(I,LM2)
          VECS(I,LM2,1) = CZERO
          DO DIMVEC=3,9
            VECS(I,LM2,DIMVEC) = CZERO
          ENDDO
        ENDDO
        DO DIMVEC=1,9
          VECSN(I,DIMVEC) = CZERO
        ENDDO
      ENDDO
C
      DO LM2=1,LMMAXD
        INFOTFX(2,LM2) = 0
        NLIM(LM2) = 1000
      ENDDO
C
      TOL=QMRBOUND
C
C
C-----------------------------------------------------------------------
C set tolerance contioned by quality of starting vector
C-----------------------------------------------------------------------
C
      IF (PR) THEN
        MAXR0 = 0.0D0
        DO LM2=1,LMMAXD
          R0INVIT = DZNRM2(NDIM,VECS(1,LM2,2),1)
          IF (R0INVIT.GT.MAXR0) MAXR0 = R0INVIT
        ENDDO
        TOL=QMRBOUND/MAXR0
      ENDIF
c     IF(IE.EQ.IELAST) TOL = 50.D0*TOL
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C
C
C
C-----------------------------------------------------------------------
C     iterative cycle begins here
C
C     --->
C     --->   ending with GOTO 10
C     --->
C
C-----------------------------------------------------------------------
C
 10   CONTINUE
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  begin loop over LM2 [1,LMMAXD] --> openMP
C-----------------------------------------------------------------------
C
C        CALL OMP_SET_NUM_THREADS(NTHRDS)
C
C!$OMP PARALLEL PRIVATE (LM2,I,DIMVEC,VECSN,INFOCORE,MYTHRD)
C
C        MYTHRD = OMP_GET_THREAD_NUM()
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C .. initilizing and call of MMZUTFX
C
C
        DO LM2=1,LMMAXD
C        IF(MOD(LM2,NTHRDS).EQ.MYTHRD) THEN
          IF (.NOT.VECDONE(LM2)) THEN
C
            DO I = 1,NDIM
              DO DIMVEC=1,9
                VECSN(I,DIMVEC)=VECS(I,LM2,DIMVEC) 
              ENDDO
            ENDDO
C
            DO DIMVEC=1,4 
              INFOCORE(DIMVEC)=INFOTFX(DIMVEC,LM2)
            ENDDO
C
            CALL MMZUTFX(NDIM,NDIM,NLIM(LM2),VECSN,TOL,INFOCORE,
     +                   RETLBLLM(LM2),
     +                   IERR(LM2),N(LM2),TF(LM2),TRES(LM2),VF(LM2),
     +                   ALPHA(LM2),BETA(LM2),ETA(LM2),RHO(LM2),
     +                   COS(LM2),VAR(LM2),R0(LM2),RESN(LM2),
     +                   TAU(LM2),UCHK(LM2),UNRM(LM2))
C
            DO DIMVEC=1,4 
              INFOTFX(DIMVEC,LM2)=INFOCORE(DIMVEC)
            ENDDO
C
            DO I = 1,NDIM
              DO DIMVEC=1,9
                VECS(I,LM2,DIMVEC)=VECSN(I,DIMVEC) 
              ENDDO
            ENDDO
C
            REVCOM(LM2)=INFOTFX(2,LM2)
            COLX(LM2)=INFOTFX(3,LM2)
            COLB(LM2)=INFOTFX(4,LM2)
C
            IF ((REVCOM(LM2).EQ.0).AND.(.NOT.VECOUT(LM2))) THEN
              VECOUT(LM2)=.TRUE.
            ENDIF
C
          ENDIF
C        ENDIF
        ENDDO
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C!$OMP END PARALLEL
C
C-----------------------------------------------------------------------
C  end loop over LM2 [1,LMMAXD]  <-- openMP
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C .. Save arrays according to LM2
C
        DO LM2=1,LMMAXD
          IF (VECOUT(LM2).AND..NOT.VECDONE(LM2)) THEN
            CALL ZCOPY(NDIM,VECS(1,LM2,1),1,X2(1,LM2),1)
            VECDONE(LM2)=.TRUE.
          ENDIF
        ENDDO
C
        REVCOMN=0 
        DO LM2=1,LMMAXD
          IF (.NOT.VECDONE(LM2)) REVCOMN=1
          IF (.NOT.VECDONE(LM2)) MMCOLB=COLB(LM2)
        ENDDO
C
C           if not converged REVCOM.EQ.1
C
        IF(REVCOMN.EQ.1) THEN
C
          DO LM2=1,LMMAXD
            IF (.NOT.VECDONE(LM2)) THEN
              DO I = 1,NDIM
                VECS(I,LM2,COLB(LM2)) = - VECS(I,LM2,COLX(LM2))
              ENDDO
            ENDIF
          ENDDO
C
CEPIK            EPIK_USER_START(r_innerloop)
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  begin loop over atoms [1,NAEZ] --> openMP
C-----------------------------------------------------------------------
C
#ifndef FPP_OMP
          CALL OMP_SET_NUM_THREADS(NTHRDS)
C
!$OMP PARALLEL PRIVATE (I1,LM2,I2,I3,I3H,I2H,IL1B,XH,MYTHRD)
C
          MYTHRD = OMP_GET_THREAD_NUM()
#endif
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
          DO I1=1,NAEZ
#ifndef FPP_OMP
          IF(MOD(I1,NTHRDS).EQ.MYTHRD) THEN
#endif
C
            DO LM2=1,LMMAXD
              IF (.NOT.VECDONE(LM2)) THEN
                DO I2=1,NUMN0(IAT)
                  I3=INDN0(I1,I2)
                  I3H = (I3-1)*LMMAXD + 1
                  I2H = (I2-1)*LMMAXD + 1
                  CALL ZCOPY(LMMAXD,VECS(I3H,LM2,COLX(LM2)),1,
     +                       XH(I2H,LM2),1)
                ENDDO
              ENDIF
            ENDDO
C
            IL1B=LMMAXD*(I1-1)
CEPIK              EPIK_USER_START(r_zgemv)
C
            CALL ZGEMM('N','N',LMMAXD,LMMAXD,NUMN0(IAT)*LMMAXD,
     +                 CONE,TGM1(1,1,I1),LMMAXD,
     +                 XH,NGTBD,
     +                 CONE,VECS(IL1b+1,1,MMCOLB),NDIM)
C
CEPIK              EPIK_USER_END(r_zgemv)
C
#ifndef FPP_OMP
          ENDIF
#endif
          ENDDO
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
#ifndef FPP_OMP
!$OMP END PARALLEL
#endif
C
C-----------------------------------------------------------------------
C  begin loop over atoms [1,NAEZ] <-- openMP
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
CEPIK            EPIK_USER_END(r_innerloop)
C
          ITCOUNT = ITCOUNT + 1
C
C-----------------------------------------------------------------------
C     go to next iterative step
C
C     --->
C     --->   10 CONTINUE
C     --->
C
C-----------------------------------------------------------------------
C
      GOTO 10                          ! back to ZUTFX
C
C
        ENDIF
C
C-----------------------------------------------------------------------
C     iterative cycle ends here left it if REVCOM.NE.1
C-----------------------------------------------------------------------
C
C
      END
C
C
C
C
