      SUBROUTINE VKSOUT(NAEZ,NSPIN,Z,ALAT,RMT,RMTNEW,RWS,
     +                 ITITLE,R,DRDI,A,B,TXC,KXC,IRNS,
     +                 LPOT,VKS,QBOUND,IRC,EFERMI,VBC,ECORE,
     +                 LCORE,NCORE)
c ************************************************************************
c      this subroutine stores in 'ifile' the necessary results
c      (potentials e.t.c.) to start self-consistency iterations
c
c       if the sum of absolute values of an lm component of vks (non
c       spher. potential) is less than the given rms error qbound this
c       component will not be stored .
c
c-----------------------------------------------------------------------
      IMPLICIT NONE
C     .. Parameters ..
      include 'inc.p'
      INTEGER LMPOTD
      PARAMETER (LMPOTD= (LPOTD+1)**2)
      INTEGER IRMIND
      PARAMETER (IRMIND=IRMD-IRNSD)
C     ..
C     .. Scalar Arguments ..
      DOUBLE PRECISION ALAT,QBOUND
      INTEGER KXC,LPOT,NAEZ,NSPIN
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION A(*),B(*),DRDI(IRMD,*),ECORE(20,*),EFERMI,
     +                 R(IRMD,*),RMT(*),RMTNEW(*),RWS(*),VBC(2),
     +                 VKS(IRMD,LMPOTD,*),Z(*)
      INTEGER IRC(*),IRNS(*),ITITLE(20,*),LCORE(20,*),NCORE(*)
      CHARACTER*24 TXC(*)
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION RV,SUM
      INTEGER I,ICORE,I1,INEW,IPOT,IR,ISPIN,ISAVE,LM,LMNR,
     +        LMPOT,NR
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C     ..
c -------------------------------------------------------------------
      ISAVE = 1
      INEW  = 1
c
      LMPOT = (LPOT+1)* (LPOT+1)
      DO I1 = 1,NAEZ
        DO ISPIN = 1,NSPIN
          IPOT = NSPIN* (I1-1) + ISPIN
          NR = IRC(I1)
c
          WRITE (10,FMT=9000) (ITITLE(I,IPOT),I=1,7),TXC(KXC+1)
          WRITE (10,FMT=9010) RMT(I1),ALAT,RMTNEW(I1)
          WRITE (10,FMT=9020) Z(I1),RWS(I1),EFERMI,VBC(ISPIN)
          WRITE (10,FMT=9030) NR,A(I1),B(I1),NCORE(IPOT),INEW
C
          IF (NCORE(IPOT).GE.1) THEN
               WRITE (10,FMT=9040) (LCORE(ICORE,IPOT),
     +              ECORE(ICORE,IPOT),ICORE=1,NCORE(IPOT))
          END IF
          WRITE (10,FMT=9050) NR,IRNS(I1),LMPOT,ISAVE
          WRITE(10,'(1P,4D20.13)') (R(IR,I1),IR=1,IRMD)
          WRITE(10,*) '    1     potential values'
          WRITE (10,FMT=9060) (VKS(IR,1,IPOT),IR=1,NR)

          LMNR = 1
          DO LM = 2,LMPOT
            SUM = 0.0D0
            DO IR = IRMIND,NR
              RV = VKS(IR,LM,IPOT)*R(IR,I1)
              SUM = SUM + RV*RV*DRDI(IR,I1)
            END DO

            IF (SQRT(SUM).GT.QBOUND) THEN
              LMNR = LMNR + 1
              IF(LM.NE.1) WRITE (10,FMT=9050) LM
              WRITE (10,FMT=9060) (VKS(IR,LM,IPOT),IR=IRMIND,NR)
            END IF

          END DO
c
c--->         write a one to mark the end
c
          IF (LMNR.LT.LMPOT) WRITE (10,FMT=9050) ISAVE

        END DO  
      END DO

 9000 FORMAT (7a4,6x,'  exc:',a24,3x,a10)
 9010 FORMAT (3f12.8)
 9020 FORMAT (f10.5,/,f10.5,2f15.10)
 9030 FORMAT (i3,/,2d15.8,/,2i2)
 9040 FORMAT (i5,1p,d20.11)
 9050 FORMAT (10i5)
 9060 FORMAT (1p,4d20.13)

      RETURN
      END
