      subroutine elementdatabase(elem_z,elem_name,color,
     &                           radious)
c      subroutine elementdatabase(elem_z,elem_name,elem_struct,
c     &     elem_alat,elem_CORE,ELEM_NOTES,pov_color,pov_radious)
      implicit none
c -----------------------------------------------------------
c  This is an element batabase
c  It takes as input the atomic number ELEM_Z
c  and returns the element name, structure, lattice constant.
c  and usual core configuration, and some notes!
c ------------------------------------------------------------
c ...Input 
      REAL*8       ELEM_Z    
c ...Output      
      REAL*8       ELEM_ALAT
      CHARACTER*3 ELEM_NAME
      CHARACTER*22 ELEM_STRUCT
      CHARACTER*80 ELEM_NOTES(3)
      INTEGER ELEM_CORE(4)
c ...Local variables
      CHARACTER*3 DATA1(0:113),DATA2,DATA3
      CHARACTER*22 STRUCT(8)
      INTEGER IN_Z,i,j,ntot,ios
      character*8 name_a(200),name_b(200)
      character*24 pov_color
      integer iatom(200)
      REAL*8       r1(200),r2(200),rad(200),pov_radious
      real*8       colorr(0:113),colorg(0:113),colorb(0:113)
      REAL*8       rmtini(0:113)
      real*8       color(3)
      real*8 radious
c           1     2       3     4     5     6     7     8     9     10
      DATA DATA1/'H1 ',
     &     'H  ','He ','Li ','Be ','B  ','C  ','N  ','O  ','F  ','Ne ',  
     &     'Na ','Mg ','Al ','Si ','P  ','S  ','Cl ','Ar ','K  ','Ca ', 
     &     'Sc ','Ti ','V  ','Cr ','Mn ','Fe ','Co ','Ni ','Cu ','Zn ',
     &     'Ga ','Ge ','As ','Se ','Br ','Kr ','Rb ','Sr ','Y  ','Zr ',
     &     'Nb ','Mo ','Tc ','Ru ','Rh ','Pd ','Ag ','Cd ','In ','Sn ',
     &     'Sb ','Te ','I  ','Xe ','Cs ','Ba ','La ','Ce ','Pr ','Nd ',
     &     'Pm ','Sm ','Eu ','Gd ','Tb ','Dy ','Ho ','Er ','Tm ','Yb ',
     &     'Lu ','Hf ','Ta ','W  ','Re ','Os ','Ir ','Pt ','Au ','Hg ',
     &     'Tl ','Pb ','Bi ','Po ','At ','Rn ','Fr ','Ra ','Ac ','Th ',
     &     'Pa ','U  ','Np ','Pu ','Am ','Cm ','Bk ','Cf ','Es ','Fm ',
     &     'Md ','No ','Lr ','Rf ','Db ','Sg ','Bh ','Hs ','Mt ','Uun',
     &     'Uuu','Uub','NoE'/
      DATA STRUCT/' Simple Cubic         ',  
     &     ' Cubic, Face centered ',
     &     ' Cubic, Boby centered ',
     &     ' Hexagonal            ',
     &     ' Rhombohedral         ',
     &     ' Tetragonal           ',
     &     ' Orthorhombic         ',
     &     ' Monoclinic           '/
c        1     2     3     4     5     6     7     8     9    
      DATA RMTINI/2.000,                                                ! 0
     &   2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,   ! 1-10
     &   2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,   ! 11-20 
     &   2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,   ! 21-30
     &   2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,   ! 31-40
     &   2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,   ! 41-50
     &   2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,   ! 51-60
     &   2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,   ! 61-70
     &   2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,   ! 71-80
     &   2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,   ! 81-90
     &   2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,   ! 91-100
     &   2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,2.000,   ! 101-110
     &   2.000,2.000,2.000/                                             ! 110-113 
c                       
c        1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20
c      DATA STRUCT/
c     &   4,4,2,4,5,4,4,1,1, 2, 4, 4/
c               
       DATA colorR/1.000,                                                ! 0
     &   1.000,1.000,1.000,1.000,1.000,0.800,0.400,0.900,0.000,0.900,   ! 1-10
     &   0.000,0.130,0.500,0.900,1.000,1.000,1.000,0.000,1.000,1.000,   ! 11-20 
     &   1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,0.900,1.000,   ! 21-30
     &   1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,   ! 31-40
     &   1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,   ! 41-50
     &   1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,   ! 51-60
     &   1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,   ! 61-70
     &   1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,   ! 71-80
     &   1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,   ! 81-90
     &   1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,   ! 91-100
     &   1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,   ! 101-110
     &   1.000,1.000,1.000/                                             ! 110-113  
      DATA colorG/1.000,                                                ! 0
     &   1.000,0.700,0.700,0.700,0.600,0.800,0.400,0.000,1.000,0.450,   ! 1-10
     &   0.000,0.400,0.500,0.600,0.500,0.850,0.000,1.000,0.100,0.000,   ! 11-20 
     &   0.000,0.000,0.000,0.000,0.000,0.500,0.000,0.000,0.500,0.000,   ! 21-30
     &   0.000,0.400,0.600,0.000,0.600,0.000,0.000,0.000,0.000,0.000,   ! 31-40
     &   0.000,0.000,0.700,0.500,0.000,0.000,0.000,0.000,0.000,0.000,   ! 41-50
     &   0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,   ! 51-60
     &   0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,   ! 61-70
     &   0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,   ! 71-80
     &   0.050,0.050,0.050,0.050,0.050,0.050,0.050,0.050,0.050,0.050,   ! 81-90
     &   0.050,0.050,0.050,0.050,0.050,0.050,0.050,0.050,0.050,0.050,   ! 91-100
     &   0.050,0.050,0.050,0.050,0.050,0.050,0.050,0.050,0.050,0.050,   ! 101-110
     &   0.050,0.050,0.050/                                             ! 110-113   
      DATA colorB/0.955,                                                ! 0
     &   1.000,0.800,0.800,0.700,0.700,0.800,1.000,0.000,0.000,0.120,   ! 1-10
     &   1.000,0.130,0.600,0.080,0.000,0.200,0.000,0.000,0.500,1.000,   ! 11-20 
     &   0.400,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.080,0.000,   ! 21-30
     &   0.600,0.700,0.800,0.900,0.300,0.200,0.400,0.200,0.100,0.000,   ! 31-40
     &   0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.300,0.000,   ! 41-50
     &   0.000,0.800,0.000,0.600,0.000,0.500,0.000,0.400,0.000,0.000,   ! 51-60
     &   0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,   ! 61-70
     &   0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,   ! 71-80
     &   0.400,0.400,0.400,0.400,0.400,0.400,0.400,0.400,0.400,0.400,   ! 81-90
     &   0.400,0.400,0.400,0.400,0.400,0.400,0.400,0.400,0.400,0.400,   ! 91-100
     &   0.400,0.400,0.400,0.400,0.400,0.400,0.400,0.400,0.400,0.400,   ! 101-110
     &   0.400,0.400,0.400/                                             ! 110-113            
c --------------------------------------------------------------------
c Get the integer part of the atomic number
      do i=1,4
      elem_core(i) = 0
      end do
      IN_Z = ELEM_Z
      IF (ABS(FLOAT(IN_Z)-ELEM_Z).GT.1.D-6) IN_Z = 113
      IF ((IN_Z.LT.0).OR.(IN_Z.GT.113)) THEN             
         WRITE (6,*) ' Ooops, This atomic number does not exist!'
         WRITE (6,*) ' ERROR in elementbatabase'
         STOP
      END IF
      ELEM_NAME = DATA1(IN_Z)
      color(1) = colorr(in_z)
      color(2) = colorg(in_z)
      color(3) = colorg(in_z)
      radious = 0.5d0
c     OPEN(UNIT=99,status='OLD',FILE='colors.data',iostat=ios)
c     write(6,*) ios
c     if (ios.gt.0) then
c     write(6,*) ' Cannot find file :   colors.data '
c     write(6,*) ' Make sure that the file is in the current path'
c     write(6,*) ' Program is stoping '
c     
c     end if
c
c     READ(99,*) NTOT
c     if (ntot.gt.200) then
c     write(6,*) 'Too many definitions in file : colors.data '
c     write(6,*) ' Program is stoping '
c     STOP
c     end if 
c     DO I=1,NTOT
c     READ(99,1000)
c    &   name_A(i),name_b(i),iatom(i),r1(i),r2(i),rad(i),color(I)
c         write(6,1000) 
c     &  name_A(i),name_b(i),iatom(i),r1(i),r2(i),rad(i),color(I) 
c     END DO
c     close(99)
c     Now asign a radious and a color to each atom.
c        pov_radious = 0.1d0
c        pov_color = 'Yellow      '
c        do j=1,ntot
c           if (iatom(j).eq.in_z) then
c              pov_radious = rad(j)
c              pov_color = color(j)
c           end if   
c        end do   
 1000 format(2A8,I3,1X,3F8.4,1X,A24)
      RETURN
      END




