      SUBROUTINE JELLSTART(NSPIN,IFILE,I13,INS,NAEZ,Z,IDSHAPE,
     &                 VOLUMECL,LPOT,
     &                 RWSCL,RMTCL,RMTCORE,MESHN,XRN,DRN,
     &                 IRWS,IRNS,
     &                 ALATNEW,QBOUND,KFG,KXC,TXC)
c ******************************************************
c * This subroutine reads a jellium potential from the database
c * file. and interpolates to the new mesh 
c ******************************************************
      implicit none
      include 'inc.geometry'
      INTEGER NPOTD
      PARAMETER (NPOTD=NSPIND*NATYPD)
      INTEGER LMPOTD
      PARAMETER (LMPOTD= (LPOTD+1)**2)
      INTEGER IRMIND,INSLPD
      PARAMETER (IRMIND=IRMD-IRNSD,INSLPD= (IRNSD+1)*LMPOTD)
      INTEGER LMXSPD
      PARAMETER (LMXSPD= (2*LPOTD+1)**2)
      INTEGER IRMDJJ
      PARAMETER(IRMDJJ=1501)
C     ..
C     .. Scalar Arguments ..
      REAL*8           ALAT,C,EFERMI,HFIELD,VCONST,ALATNEW,
     &                 QBOUND
      INTEGER IFILE,IINFO,INS,
     +        KHFELD,KSHAPE,KVREL,KWS,
     +        LMAX,LPOT,
     +        NBEG,NEND,NSPIN,KXC
C     ..
C     .. Array Arguments ..
      REAL*8       Z(NATYPD),
     +             VOLUMECL(*),
     +             RWSCL(*),
     +             RMTCL(*),
     +             RMTCORE(*),
     +             XRN(IRID,NATYPD),
     +             DRN(IRID,NATYPD)
      INTEGER      IRNS(NATYPD),
     +             IRWS(NATYPD),
     +             ITITLE(20),
     +             LCORE(20),NCORE,
     +             IDSHAPE(*),
     +             KFG(4,NATYPD)

C     ..
C     .. Local Scalars ..
      REAL*8       A1,B1,EA,EFNEW,S1,Z1,DUMMY,RMAX,RMTNW1,RMT1,
     &             VBC(2),VCON,maxa,aout,bout,rmtout,
     &             parsum,parsumderiv,r0,dist,dr,rmaxout,rmtnew
      REAL*8       RWS0,br,za,zvali,einf,ar,amsh
      INTEGER I,J,IA,ICELL,ICORE,IFUN,IH,IMT1,INEW,IO,IPAN1,IR,IRC1,IRI,
     +        IRMINM,IRMINP,IRNS1P,IRT1P,IRWS1,ISAVE,ISPIN,ISUM,
     +        NAEZ,IPOT,IRNSTOT,MESHN(NATYPD),MESHN0,ID,
     +        L,LM,LM1,LMPOT,LMPOTP,IRNSOUT,IRMTOUT,IRWSOUT,
     +        N,NCELL,NFUN,NR,IAT,IRNS1,NCORE1,NCOREINF,IRC,nz,
     &        irs1,nsec,NZVALI,nc,ii,i1,i2
      LOGICAL TEST,potlm(lmpotd),FOUND,JFOUND(20),INF
C     ..
C     .. Local Arrays ..
      REAL*8           U(IRMD),DRDI(IRMDJJ),
     +                 ECORE(20),ECORE1(20),ECOREINF(20),
     &                 R(IRMDJJ),RWS,VINS(IRMIND:IRMD,LMPOTD),
     &                 VM2Z(IRMDJJ),vinsout(IRMIND:IRMD,LMPOTD),
     &                 vm2zout(IRMD),vm2zb(IRMDJJ),rout(IRMD),
     &                 vinsb(IRMD,LMPOTD),DRDIOUT(IRMD),            
     &                 work(IRMD,LMPOTD),ra(irmd) 
      INTEGER          LCORE1(20),
     +                 LCOREINF(20)
      CHARACTER*40     BANER,TEXT,I13
      CHARACTER*4      ELEM_NAME,AAAA,TRAN,exte 
      CHARACTER*24     TXC(3)
      CHARACTER*4      ELEM_FILE(0:113)
      character*26     atompot
      CHARACTER*2      TXTC(20)
      character*20     	data1
       DATA ELEM_FILE/'Vac0',
     & 'H_01','He02','Li03','Be04','B_05','C_06','N_07','O_08',
     & 'F_09','Ne10',
     & 'Na11','Mg12','Al13','Si14','P_15','S_16','Cl17','Ar18',
     & 'K_19','Ca20','Sc21','Ti22',
     & 'V_23','Cr24','Mn25','Fe26','Co27','Ni28',
     & 'Cu29','Zn30',
     & 'Ga31','Ge32','As33','Se34','Br35','Kr36','Rb37','Sr38',
     & 'Y_39','Zr40',
     & 'Nb41','Mo42','Tc43','Ru44','Rh45','Pd46','Ag47','Cd48',
     & 'In49','Sn50',
     & 'Sb51','Te52','I_53','Xe54','Cs55','Ba56','La57','Ce58',
     & 'Pr59','Nd60',
     & 'Pm61','Sm62','Eu63','Gd64','Tb65','Dy66','Ho67','Er68',
     & 'Tm69','Yb70',
     & 'Lu71','Hf72','Ta73','W_74','Re75','Os76','Ir77','Pt78',
     & 'Au79','Hg80',
     & 'Tl81','Pb82','Bi83','Po84','At85','Rn68','Fr87','Ra88',
     & 'Ac89','Th90',
     & 'Pa91','U_92','Np93','Pu94','Am95','Cm96','Bk97','Cf98',
     & 'Es99','Fm__',
     & 'Md__','No__','Lr__','Rf__','Db__','Sg__','Bh__','Hs__',
     & 'Mt__','Uun_',
     & 'Uuu_','Uub_','NoE_'/
c     --------------------------------------------------------------
      WRITE(6,*) ' ****  READING  POTENTIAL  **** '
c      open(ifile,status='old',FILE=I13,ERR=1000)
      open(19,status='unknown',FILE='output.pot')
c      VINS = 0.D0
c      VM2Z = 0.d0
      DO I2=1,LMPOTD
         DO I1=IRMIND,IRMD
            VINS(I1,I2) = 0.D0
         END DO
      END DO
      DO I1=1,IRMDJJ
         VM2Z(I1) = 0.D0
      END DO
C
C=======================================================================
C begin atom loop
C=======================================================================
C
      DO IAT =1,NAEZ
         DO ISPIN=1,NSPIN
            do lm=1,lmpotd
               POTLM(LM) =.false.
            end do
            IPOT =  NSPIN* (IAT-1) + ISPIN    
            
c     READ(IFILE,8010) ELEM_NAME,Z1
c     IF (NSPIN.EQ.1) THEN
c     WRITE (6,8011) ELEM_NAME,Z1
c     ELSEIF (ISPIN.EQ.1) THEN
c     WRITE (6,8012) ELEM_NAME,Z1
c     ELSEIF (ISPIN.EQ.2) THEN
c     WRITE (6,8013) ELEM_NAME,Z1
c     END IF
c
c Find out what atom is needed            
c            
            NZ = Z(IAT)
            if (((nz.ge.24.and.nz.le.28).or.(nz.ge.57.and.nz.le.70))
     &                                          .and.ispin.eq.2) then
            atompot = 'ElementDataBase/'//ELEM_FILE(NZ)//'.pots2'
            else
            atompot = 'ElementDataBase/'//ELEM_FILE(NZ)//'.pot  '
            end if
            write(6,*) 'Using database ....: ',atompot
            open(21,status='old',FILE=atompot,ERR=1010)
            IRWS1 =  NR
            
c --------------------------------------------------------------------
          
           EFERMI = .409241D+00
           VBC(1)    = .500D0
           VBC(2)    = .500D0
c          read potential from jellium
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
           READ(21,141) BANER,AAAA,AAAA
           READ(21,142) RWS0,S1,IRS1,BR
           READ(21,142) ZA,ZVALI,NSEC,EINF
c     Calculate number of core states
           NZ = ZA               ! make integer
           NZVALI = ZVALI       ! make integer
           NC = NZ - NZVALI
           NCORE = 0
           IF (NC.eq.2 ) NCORE = 1 ! 1s
           IF (NC.eq.4 ) NCORE = 2 ! 1s2s
           IF (NC.eq.10) NCORE = 3 ! 1s2s2p
           IF (NC.eq.12) NCORE = 4 ! 1s2s2p3s
           IF (NC.eq.18) NCORE = 5 ! 1s2s2p3s3p
           IF (NC.eq.28) NCORE = 6 ! 1s2s2p3s3p3d
           IF (NC.eq.30) NCORE = 7 ! 1s2s2p3s3p3d4s
           IF (NC.eq.36) NCORE = 8 ! 1s2s2p3s3p3d4s4p
           IF (NC.eq.46) NCORE = 9 ! 1s2s2p3s3p3d4s4p4d
           IF (NC.eq.48) NCORE = 10 ! 1s2s2p3s3p3d4s4p4d4s
           IF (NC.eq.54) NCORE = 11 ! 1s2s2p3s3p3d4s4p4d4s4p
           IF (NC.eq.68) NCORE = 12 ! 1s2s2p3s3p3d4s4p4d4s4p4f
           IF (NC.eq.78) NCORE = 13 ! 1s2s2p3s3p3d4s4p4d4s4p4f5d  
           IF (NC.eq.80) NCORE = 14 ! 1s2s2p3s3p3d4s4p4d4s4p4f5d6s
           IF (NC.eq.86) NCORE = 15 ! 1s2s2p3s3p3d4s4p4d4s4p4f5d6s4p 
           WRITE(6,*) '*************************************'
           WRITE(6,*) '   Potential Interpolation Program   '
           WRITE(6,*) '   Using the Jellium Database v1.0   '
           WRITE(6,*) '*************************************'
!           WRITE(6,*)
!           write(6,*) 'OUTPUT POTENTIAL : fort.1 ' 
!           WRITE(6,*)
           WRITE(6,163) EFERMI
!           WRITE(6,*)
!           WRITE(6,*)
           WRITE(6,161) ZA  
           WRITE (6,162) NCORE
           READ(21,133)(LCORE(NC),TXTC(NC),ECORE(NC),NC=1,NCORE)
           WRITE(6,*) ' ** Position of the Core States ** '
C
C obtain L, E and total number of core states on the basis of
C jellium potential defaults:
C
           DO I=1,NCORE
              WRITE(6,135) LCORE(I),TXTC(I),ECORE(I)
              IF (TXTC(I).eq.'s ') LCORE(i) = 0
              IF (TXTC(I).eq.'p ') LCORE(i) = 1
              IF (TXTC(I).eq.'d ') LCORE(i) = 2
              IF (TXTC(I).eq.'f ') LCORE(i) = 3
           END DO
C
C obtain L, E and total number of core states on the basis of
C atominfo (KFG):
C
           NCOREINF = 0
           DO LM=1,20
             LCOREINF(LM) = 0
             ECOREINF(LM) = 0.0D0
           ENDDO
C
           DO I=1,4
             IF (KFG(I,IAT).GT.I-1) THEN
               NCOREINF = NCOREINF + KFG(I,IAT) - (I-1)
               DO LM = (NCOREINF-KFG(I,IAT)+I), NCOREINF+1
                 LCOREINF(LM) = I-1
               ENDDO
             ENDIF
           ENDDO
C
           DO J=1,NCORE
             JFOUND(J) = .FALSE.
           ENDDO
C
           DO I=1,NCOREINF
             FOUND = .FALSE.
             DO J=1,NCORE
               IF (LCORE(J).EQ.LCOREINF(I)
     +             .AND..NOT.FOUND.AND..NOT.JFOUND(J)) THEN
                 ECOREINF(I) = ECORE(J)
                 FOUND       = .TRUE.
                 JFOUND(J)   = .TRUE.
               ENDIF
             ENDDO
           ENDDO
C
!        IF (ISPIN.EQ.1) THEN
!          WRITE(6,*) '#####################'
!          WRITE(6,*) '#ATOM:',IAT
!          WRITE(6,*) '#NCORE:',NCOREINF
!          WRITE(6,*) '#KFG:',KFG(1,IAT),KFG(2,IAT),KFG(3,IAT),KFG(4,IAT)
!          WRITE(6,*) '#LCORE:',(LCOREINF(LM),LM=1,NCOREINF)
!          WRITE(6,*) '#ECORE:',(ECOREINF(LM),LM=1,NCOREINF)
!          WRITE(6,*) '#####################'
!        ENDIF
C
C
C now copy core-state configuration to write-buffer
C if INF = .TRUE. use information in file atominfo, otherwise
C default in jellium potential
C
           INF = .TRUE.
C
           IF (INF) THEN
             NCORE1 = NCOREINF
             DO I=1,NCOREINF
                LCORE1(I) = LCOREINF(I)
                ECORE1(I) = ECOREINF(I)
             ENDDO
           ELSE
             NCORE1 = NCORE
             DO I=1,NCORE1
               LCORE1(I) = LCORE(I)
               ECORE1(I) = ECORE(I)
             ENDDO
           ENDIF

           Write(6,134) EINF
           write(6,*) '**********************************************'  
c 
           READ(21,131)(VM2Z(II),II=1,IRS1)
           READ(21,132)TRAN
           CLOSE (21)
c     make mesh r0
           AR = LOG(S1/BR+1.D0)/FLOAT(IRS1-1)
           EA=EXP(AR)
           AMSH=1.D0
           R(1)=0.D0
           DRDI(1)=BR*AR
           DO 1 I=2,IRS1
              AMSH=AMSH*EA
              R(I)=BR*(AMSH-1.D0)
              DRDI(I)=DRDI(1)*AMSH
 1         CONTINUE
           write(6,*) 'Jellium Potential Read In ',irs1,' points'
           NR = IRS1
           Z1 = ZA
C     
 131       FORMAT(4D15.8)
 132       FORMAT(A4)
 133       FORMAT(I3,A2,D15.8)
 135       FORMAT(I3,A2,F15.6,' Ry')
 134       FORMAT('All other states are above :',F8.4,' Ry in Energy')
 141       FORMAT(3X,A40,3X,A4,3X,A4)
 142       FORMAT(7X,F8.4,7X,F8.4,7X,I5,7X,F8.4)
 161       FORMAT('Potential Atomic Number :',F7.2)
 162       FORMAT('Number of Core   States :',I4)
 163       FORMAT('Jellium Fermi Energy :',F10.5,' Ry')
c --------------------------------------------------------------------
c     
c     The input mesh is constructed now Construct the output mesh
c     
            ID = IDSHAPE(IAT)
            ROUT(1) = 0
            AOUT = 0.025D0  ! 
            RMAXOUT = RWSCL(ID)    ! although it gets processed RMAXOUT 
                                   ! is always equal RWSCL(ID)
            RMTOUT  = RMTCL(ID)
            IRWSOUT = IRWS(IAT)
            IRMTOUT = IRWS(IAT) - MESHN(ID)
            IRNSOUT = IRNS(ID)

C          write(6,*) '&& &&',RMAXOUT,RMTOUT,IRWSOUT,IRMTOUT,IRNSOUT 
C          write(6,*) '&& &&',INS,MESHN(ID)
            IF (INS.EQ.0) then
               BOUT = RMAXOUT / (EXP(AOUT*REAL(IRWSOUT-1))-1.0D0)
               DO IR=2,IRWSOUT
                  EA = EXP(AOUT*REAL(IR-1))
                  ROUT(IR) = BOUT* (EA-1.0D0)
                  DRDIOUT(IR) = AOUT*BOUT*EA
               End DO 
               do i=1,irwsout
                if (rout(i).lt.rmtout) irmtout = i
               end do
               if (MOD(IRMTOUT,2).EQ.0) IRMTOUT = IRMTOUT+1
               RMTNEW = ROUT(IRMTOUT)
               RMAXOUT = ROUT(IRWSOUT)
            ELSE
               BOUT = RMTOUT /  (EXP(AOUT*REAL(IRMTOUT-1))-1.0D0)
               DO IR=2,IRMTOUT
                  EA = EXP(AOUT*REAL(IR-1))
                  ROUT(IR) = BOUT* (EA-1.0D0)
                  DRDIOUT(IR) = AOUT*BOUT*EA
               End DO
               DO IRI=1,MESHN(ID)
                  IR = IRI + IRMTOUT
                  ROUT(IR) = ALATNEW*XRN(IRI,ID)   ! scaling is always 1.0d0
                  DRDIOUT(IR) = ALATNEW*DRN(IRI,ID)
               ENd DO
               RMTNEW = ROUT(IRMTOUT)
               RMAXOUT = ROUT(IRWSOUT)
            END IF
c
c       write(6,*) irwsout,irmtout,rmtnew,rmaxout
c       do i=1,irwsout
c         write(6,*) 'out',i,rout(i)
c       end do            
c
c  Ok now interpolate
c
                   
          maxa = 1.d35
          CALL SPLINE(IRMDJJ,R,VM2Z,NR,maxa,maxa,VM2ZB)  
c          write(6,*) 'check 1'
          
c
c OK with spline
c
          vm2zout(1) = vm2z(1)
          DO IR = 2,IRWSOUT
             R0 = ROUT(IR)
             CALL SPLINT(R,VM2Z,VM2ZB,NR,R0,PARSUM,PARSUMDERIV)
             VM2ZOUT(IR) = PARSUM
c             write(6,*)'newpot',ir,r0,vm2zout(ir)
          END DO
c

        
c
          IF (INS.GT.0) THEN
             IRC = IRWSOUT - IRNSOUT
             DO LM1=1,LMPOTD
                ! if (potlm(lm1)) then
                DO IR = IRC,IRWSOUT   ! bug fixed 25.5.2001
                   VINSOUT(IR,LM1) = 0.d0
                END DO
                ! end if
             end do
          END IF
C
          CALL RITESONE(19,ISPIN,Z1,ALATNEW,RMTOUT,RMTNEW,RMAXOUT,
     +                 ITITLE,ROUT,DRDIOUT,VM2ZOUT,IRWSOUT,AOUT,BOUT,
     &                 TXC,KXC,INS,IRNSOUT,
     +                 LPOT,VINSOUT,QBOUND,IRWSOUT,KSHAPE,EFERMI,VBC,
     &                 ECORE1,LCORE1,NCORE1,ELEM_FILE(NZ),NSPIN) ! bug fixed 25.5.2001
c
c
c Next atom or next spin
c
          END DO
       END DO  
C      
C=======================================================================
C end atom loop
C=======================================================================
C
       
       RETURN
 1000  write(6,*) 'Error read file......... ',I13
       write(6,*) 'Error occured on atom... ',iat
       STOP
 1010  write(6,*) ' Error in JELLSTART '
       write(6,*) ' Potential.............',ELEM_FILE(NZ)
       write(6,*) ' Does not exist in the database'
       STOP
 8000 format (A40)
 8010 format (3X,A4,26X,F8.3)
 8011 Format ('#  ',A4,'POTENTIAL             Z = ',F8.3)
 8012 format ('#  ',A4,'POTENTIAL SPIN UP     Z=  ',F8.3)
 8013 format ('#  ',A4,'POTENTIAL SPIN DOWN   Z=  ',F8.3)
 8020  FORMAT(A40)
 8030 format (4f12.8)
 8040 format (1X,3I6)
 8050 format (2D15.8)
 8060 format (3f12.8)
 8070 format (2I5)
 9051 FORMAT (1p,4d20.12)
 9000 FORMAT (7a4,6x,'  exc:',a24,3x,a10)
 9010 FORMAT (3f12.8)
 9020 FORMAT (f10.5,/,f10.5,2f15.10)
 9030 FORMAT (i3,/,2d15.8,/,2i2)
 9140 FORMAT (i5,1p,d20.11)
 9040 FORMAT (f10.5,/,f10.5,2f15.10)
 9050 FORMAT (i3,/,2d15.8,/,2i2)
 9060 FORMAT (1p,2d15.6,1p,d15.8)
 9160 FORMAT (10i5)
 9061 FORMAT (1p,5d15.8)
 9070 FORMAT (i5,1p,d20.11)
c 9080 FORMAT (10x,20a4)
 9080 FORMAT (' < ',20a4)
 9081 FORMAT (' <#',20a4)
 9090 FORMAT (10i5)
 9100 FORMAT (1p,4d20.13)
        END








