      SUBROUTINE MTMESH(NRAD,NPAN,MESHN,NM,XRN,DRN,
     &                  NFU,THETAS,LMIFUN,MTRADIUS)
C
      IMPLICIT NONE
C
      INCLUDE 'inc.geometry'
C
C
C Program  mtmesh.f adds one extra pannel inside the
C muffin-tin sphere to allow lattice relaxations.
C stores the mt-nized shapes in unit 15 as shapefun
C     .. Parameters ..
c     nrad : number of points added inside the MT radius
      Integer ibmaxd
      Parameter (IBMAXD=(LMAXD1+1)*(LMAXD1+1))
      INTEGER NRAD
c      Parameter (nrad=20)
C     ..
C     .. Local Scalars ..
      REAL*8           dist,dn1,mtradius,pi,scale
      Integer ifun,ipan1,ir,lm,meshn,nfu,npan,number
      integer ip,i
C     ..
C     .. Arrays ..
      REAL*8           drn(IRID),thetas(IRID,ibmaxd),xrn(IRID)
      Integer nm(npand),lmIFUN(ibmaxd)
C     ..
C     .. Local Arrays ..      
      REAL*8           drn1(IRID),thetas1(IRID,ibmaxd),xrn1(IRID)
      Integer nm1(npand)
      integer meshn1,npan1
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,DATAN,DSQRT,SQRT
C     ..
      PI = 4.D0*DATAN(1.D0)

      NPAN1 = NPAN + 1
      MESHN1 = MESHN + NRAD
      NM1(1) = NRAD
      
      DO IP=2,NPAN1
         NM1(IP) = NM(IP-1)
      END DO

      IF (NPAN1.GT.NPAND) THEN
        WRITE (6,FMT=*) ' NPAN , NPAND ',NPAN1,NPAND
        STOP
      END IF
      
      IF (MESHN1.GT.IRID) THEN
        WRITE (6,FMT=*) ' MESHN , IRID ',MESHN1,IRID
        STOP
      END IF

      DIST = XRN(1) - MTRADIUS

      If (dist.lt.1.0d-5) Then
         Write (6,FMT=*) 'Error from MTMESH '
         write (6,*) 
     & 'Your MT-radious is biger that the minimum shape radious ' 
         write(6,*) 'Your MT-Radious .....',mtradius
         write(6,*) 'Shape Radious .......',xrn(1)    
        Stop
      End if
           
      dn1 = dist/ (nrad-1)
      xrn1(nrad) = xrn(1)
      drn1(nrad) = dn1
      Do ir = 1,nrad-1
        xrn1(ir) = mtradius + dn1* (ir-1)
        drn1(ir) = dn1
      End do
      do i=1,meshn1-nrad
         xrn1(i+nrad) = xrn(i)
         drn1(i+nrad) = drn(i) 
      end do

      Do ir = 1,nrad
        thetas1(ir,1) = dsqrt(4.d0*pi)
        Do ifun = 2,ibmaxd
          thetas1(ir,ifun) = 0.0d0
        End do
      End do

      Do 10 ifun = 1,nfu
        do ir=1,meshn1-nrad
         thetas1(nrad+ir,ifun) = thetas(ir,ifun)
        end do
   10 Continue
c
c  Now map back and return. 
c
      npan = npan1
      meshn = meshn1

      do ip=1,npan
         nm(ip) = nm1(ip)
      end do  
      do ir=1,meshn
         xrn(ir) = xrn1(ir)
         drn(ir) = drn1(ir)
      end do

      Do ifun = 1,nfu
        do ir=1,meshn
         thetas(ir,ifun) = thetas1(ir,ifun)
        end do
      end do
c
c Now store on disk
c
      WRITE(15,FMT=9000) NPAN,MESHN
      WRITE(15,FMT=9000) (nm(ipan1),ipan1=1,npan)
      WRITE(15,FMT=9010) (xrn(ir),drn(ir),ir=1,meshn)
      WRITE(15,FMT=9000) nfu
      DO IFUN = 1,NFU
        WRITE(15,FMT=9000) lmifun(ifun)
c         Write (6,FMT=*)     lmifun(ifun)
        WRITE(15,FMT=9010) (thetas(ir,ifun),ir=1,meshn)
      ENDDO
      RETURN 
 9000 FORMAT (16i5)
 9010 FORMAT (4d20.12)
      End



