      SUBROUTINE POTENTIAL(
     >                     NAEZ,NSPIN,INS,LPOT,Z,ALATC,KFG,KXC,TXC,
     >                     QBOUND,I13,
     >                     IRWS,IRNS,RWSCL,RMTCL,RMTCORE,
     >                     IDSHAPE,VOLUMECL,
     >                     MESHN_S,XRN_S,DRN_S)
C     ..
C     .. Parameters ..
      include 'inc.geometry'
C     ..
C     .. Scalar Arguments ..
      REAL*8        ALATC,QBOUND
      INTEGER       NAEZ,NSPIN,INS,LPOT,KXC
      CHARACTER*40  I13
C     ..
C     .. Array Arguments ..
      REAL*8        Z(NATYPD),
     +              VOLUMECL(NATYPD),
     +              RWSCL(NATYPD),
     +              RMTCL(NATYPD),
     +              RMTCORE(NATYPD),
     +              XRN_S(IRID,NATYPD),
     +              DRN_S(IRID,NATYPD)
      INTEGER       IDSHAPE(NATYPD),
     +              MESHN_S(NATYPD),
     +              IRWS(NATYPD),
     +              IRNS(NATYPD),
     +              KFG(4,NATYPD)
      CHARACTER*24  TXC(3)
C     ..
C     .. Local Scalars ..
      REAL*8        A1
      INTEGER       IAT
      CHARACTER*3   ELEM_NAME
      CHARACTER*24  TEXT
C     ..
C     .. Local Arrays ..
C     ..
C=======================================================================
C=======================================================================
C
C
       WRITE (6,*)
       WRITE(6,'(79(1H=),/,15X,A)')
     &     'maindriver: POTENTIAL, begin'
       WRITE (6,'(79(1H=),/)')
       WRITE (6,*)

       IF (INS.EQ.0) THEN 
         WRITE(6,*) 'Spherical Potential Output '
       ELSE
         WRITE(6,*) 'Full Potential Output '
       ENDIF
C
C
C=======================================================================
       IF (I13(1:7).NE.'       ') THEN      ! Start from given potential
C=======================================================================
C
         WRITE(6,1190) I13
         WRITE(6,*) ' If potentials do not match program will stop '
         WRITE(6,*) ' Expect to find the following potentials '
C
         DO IAT =1,NAEZ
C
           CALL ELEMENTDATABASE(Z(IAT),ELEM_NAME,TEXT,A1)
           IF (NSPIN.EQ.2) THEN
             WRITE(6,1200) ELEM_NAME
             WRITE(6,1210) ELEM_NAME
           ELSE
             WRITE(6,1220) ELEM_NAME
           ENDIF
C
         ENDDO
C
         CALL GENPOTSTART(NSPIN,11,I13,INS,NAEZ,Z,IDSHAPE,VOLUMECL,
     &                    LPOT,RWSCL,RMTCL,
     &                    RMTCORE,MESHN_S,XRN_S,DRN_S,
     &                    IRWS,IRNS,ALATC,
     &                    QBOUND,KXC,TXC)
C
C
C=======================================================================
       ELSE                               ! Start from jellium potential
C=======================================================================
C
         WRITE(6,*) ' No potential file specified: jellium potentials'
C
         CALL JELLSTART(NSPIN,11,I13,INS,NAEZ,Z,IDSHAPE,VOLUMECL,
     &                  LPOT,RWSCL,RMTCL,
     &                  RMTCORE,MESHN_S,XRN_S,DRN_S,
     &                  IRWS,IRNS,ALATC,
     &                  QBOUND,KFG,KXC,TXC)
C
C=======================================================================
       ENDIF
C=======================================================================
C
C
C=======================================================================

       WRITE (6,*)
       WRITE(6,'(79(1H=),/,15X,A)')
     &     'maindriver: POTENTIAL, end'
       WRITE (6,'(79(1H=),/)')
       WRITE (6,*)
C
C=======================================================================
C=======================================================================
C
C
C
 1190    format('Potential file will be used ........ ',A40/
     &        '**** MUST BE IN GENERAL FORMAT ****'/) 
 1200    format(A3,'  POTENTIAL SPIN DOWN ')
 1210    format(A3,'  POTENTIAL SPIN UP   ' ) 
 1220    format(A3,'  POTENTIAL ')
C
C
C
      END


