      SUBROUTINE READINPUT(RBASIS,ABASIS,BBASIS,CBASIS,
     +                     ALATC,CLS,NCLS,REFPOT,
     +                     IRNS,NTCELL,NAEZ,KAOEZ,IRM,Z,
     +                     NINEQ,NTCELLR,
     +                     IFILE,INS,
     +                     KFG,KWS,KXC,LMAX,LPOT,
     +                     NATYP,NSPIN,
     +                     TXC,LMXC,
     +                     KMT,MTFAC,I13,
     &                     RCUTZ,RCUTXY,RMTCORE,
     &                     SIZEFAC)
      implicit none
      include 'inc.geometry'
C     .. Local Arrays ..
      CHARACTER*4 TSPIN(2)
      CHARACTER*8 TKWS(3)
      CHARACTER*43 TINS(0:3),TKCOR(0:3),TVREL(0:2)
C     ..
C     .. External Subroutines ..
      EXTERNAL RCSTOP
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MIN
C     ..
C     .. Array Arguments ..
      INTEGER  IRNS(*),KFG(4,*),LMXC(NAEZD),
     +         NTCELL(*),CLS(*),REFPOT(NAEZD)
      INTEGER  NTCELLR(*),KAOEZ(*)
      REAL*8        Z(*),MTFAC(*),RBASIS(3,*),RMTCORE(*)
      REAL*8        SIZEFAC(0:NAEZD)
      CHARACTER*24 TXC(3)
      CHARACTER*80 UIO
      CHARACTER*40 I12,I13,I19,I25,I40
C     ..
C     .. Scalar Arguments ..
      REAL*8  E1,E2,ESHIFT,FCM,HFIELD,MIXING,QBOUND,TK,
     +        VCONST,ABASIS,BBASIS,CBASIS,RCUTZ,RCUTXY
      INTEGER ICC,IFILE,INS,INSREF,
     +        IPOTOU,IPRCOR,
     +        IRM,IRNUMX,ISHIFT,ITCCOR,ITCLST,ITDBRY,
     +        KFROZN,KHFELD,KHYP,KPRE,KSHAPE,KTE,
     +        KWS,KXC,LMAX,LMMAX,LMPOT,LPOT,MD,
     +        NATYP,NPNT1,NPNT2,NPNT3,NPOL,NSPIN
      INTEGER NSTEPS,KMT,NAEZ
      INTEGER NINEQ
      REAL*8  ALATC,BLATC,CLATC
      INTEGER MMIN,MMAX,SINN,SOUT,RIN,ROUT
      INTEGER INTERVX,INTERVY,INTERVZ,NREF,NCLS
      INTEGER NLBASIS,NRBASIS,NLEFT,NRIGHT          ! new1
C     ..
C     .. Local Scalars ..
      REAL*8        E3,TX,TY,TZ
      INTEGER I,IL,IP,J,IER,I1,IC,II,M2
      CHARACTER*43 TSHAPE
c
      CHARACTER*8 TESTC(16),OPTC(8)
      COMMON /TESTC/TESTC
      COMMON /OPTC/OPTC
C     ..
C     .. Data statements ..
      DATA TSPIN/'non-','    '/
      DATA TSHAPE/' exact cell treatment (shape correction)  '/
      DATA TVREL/
     +     ' non relativistic calculation              ',
     +     ' s.r.a. calculation                        ',
     +     ' s.r.a. calculation                        '/
      DATA TKCOR/
     +     ' frozen core approximation                 ',
     +     ' core relaxation s.r.a.                    ',
     +     ' core relaxation nonsra                    ',
     +     ' core relaxation                           '/
      DATA TINS/' spherical averaged input potential        ',
     +     ' non spherical input potential for cluster ',
     +     ' non spherical input potential for cluster ',
     +     ' non spherical input potential             '/
      DATA TKWS/' full mt','   ws   ',' full ws'/
C     ..
c
c------------ array set up and definition of input parameter -----------
c
      TXC(1) = ' Morruzi,Janak,Williams '
      TXC(2) = ' von Barth,Hedin        '
      TXC(3) = ' Vosko,Wilk,Nusair      '


c      READ (7,1002) (HEAD(I) ,I=1,80)
      IL=1
      CALL IoInput('NSPIN     ',UIO,1,7,IER)
                         READ (UNIT=UIO,FMT=*) NSPIN
      CALL IoInput('NATYP    ',UIO,1,7,IER)
                        READ (UNIT=UIO,FMT=*) NATYP     
      CALL IoInput('NAEZ      ',UIO,1,7,IER)
                        READ (UNIT=UIO,FMT=*) NAEZ

      WRITE(6,8000) NAEZ,NATYP,NSPIN
 8000 FORMAT('NAEZ=',I5,' ; NATYP=',I5' ; NSPIN=',I2)

      IF(NAEZ.GT.NAEZD) THEN
        WRITE(6,*) 'Please, increase the parameter naezd (',naezd,
     +       ') in inc.p to',naez
        STOP 'ERROR in NAEZD.'
      ENDIF


C
C
      OPEN(77,FILE='atominfo',FORM='formatted')
      DO I=1,NAEZ
                           READ (UNIT=77,FMT=*)    Z(I),
     +                        LMXC(I),
     +                       (KFG(J,I),J=1,4),
     +                        CLS(I),
     +                        REFPOT(I),
     +                        NTCELL(I),
     +                        MTFAC(I),
     +                        IRNS(I),
     +                        RMTCORE(I),SIZEFAC(I)
      END DO
      CLOSE (77)
C
C

         CALL IoInput('KMT       ',UIO,1,7,IER)
                            READ (UNIT=UIO,FMT=*) KMT
      WRITE(6,2028) NATYP
      WRITE(6,2104)
      WRITE(6,1029) (
     +     Z(I),
     +     LMXC(I),
     +     (KFG(J,I),J=1,4),
     +     CLS(I),
     +     REFPOT(I),
     +     NTCELL(I),
     +     MTFAC(I),
     +     IRNS(I),RMTCORE(I),SIZEFAC(I),I=1,NATYP)
      WRITE(6,2108)
      WRITE(6,2029) KMT
      WRITE(6,2104)
c
c---> read input
c
      IL=1
      CALL IoInput('LMAX      ',UIO,0,7,IER)
                    READ (UNIT=UIO,FMT=*) LMAX
      CALL IoInput('EMIN      ',UIO,1,7,IER)
                    READ (UNIT=UIO,FMT=*) E1

      CALL IoInput('IRNUMX    ',UIO,1,7,IER)
                    READ (UNIT=UIO,FMT=*) irnumx
      CALL IoInput('ITCCOR    ',UIO,1,7,IER)
                     READ (UNIT=UIO,FMT=*) itccor
      CALL IoInput('IPRCOR    ',UIO,1,7,IER)
                     READ (UNIT=UIO,FMT=*) iprcor

      CALL IoInput('IFILE     ',UIO,1,7,IER)
                     READ (UNIT=UIO,FMT=*) ifile
      CALL IoInput('ISHIFT    ',UIO,1,7,IER)
                     READ (UNIT=UIO,FMT=*) ishift
c      CALL IoInput('ESHIFT    ',UIO,1,7,IER)
c                     READ (UNIT=UIO,FMT=*) eshift
       ESHIFT = 0.d0   
      CALL IoInput('KSHAPE    ',UIO,1,7,IER)
                      READ (UNIT=UIO,FMT=*) kshape
      CALL IoInput('IRM       ',UIO,1,7,IER)
                      READ (UNIT=UIO,FMT=*) irm
      CALL IoInput('INS       ',UIO,1,7,IER)
                      READ (UNIT=UIO,FMT=*) ins
      CALL IoInput('INSREF    ',UIO,1,7,IER)
                      READ (UNIT=UIO,FMT=*) insref
     

      CALL IoInput('KWS       ',UIO,1,7,IER)
                      READ (UNIT=UIO,FMT=*) kws
      CALL IoInput('KEXCOR    ',UIO,1,7,IER)
                      READ (UNIT=UIO,FMT=*) kxc    
c
      

      
c ------------------------------------------------------------------------
      WRITE (6,9210) LMAX
      WRITE (6,9301)
      WRITE (6,9250) IFILE,ISHIFT,ESHIFT
      WRITE (6,9305)
      WRITE (6,9260) KSHAPE,IRM,INS,INSREF
c ------------------------------------------------------------------------

c ------------------------------------------------------------------------
c
      IF (KSHAPE.NE.0) KWS = 2
c
      LMMAX = (LMAX+1)**2
      LPOT  = MIN(2*LMAX,LPOTD)
      LMPOT = (LPOT+1)* (LPOT+1)
c
      WRITE (6,FMT=9020) LMAX,LMAXD,NATYP,NATYPD,IRM,IRMD,NSPIN,NSPIND


      IF (INS.GT.0) THEN
        WRITE (6,FMT=9130)
        WRITE (6,FMT=9140)
        DO 20 I = 1,NATYP
          WRITE (6,FMT=9150) I,IRNS(I),IRNSD

          IF (IRNS(I).GT.IRNSD) CALL RCSTOP('19      ')

   20   CONTINUE

        IF (LMAX.NE.LMAXD) THEN
          WRITE (6,FMT=9120)

          CALL RCSTOP('20      ')

        END IF

      END IF


      WRITE (6,FMT=9130)
c
c
c
c
      WRITE (6,FMT=9050) TSPIN(NSPIN)
      IF (KSHAPE.EQ.0) THEN
        WRITE (6,FMT=9070) TKWS(KWS+1)

      ELSE
        WRITE (6,FMT=9170) TSHAPE
      END IF

      WRITE (6,FMT=9100) TXC(KXC+1)
      IF (INS.GT.0) WRITE (6,FMT=9160) TINS(INS)
      WRITE (6,FMT=9080)

c
c

      write(6,2110)
      IF(NAEZ.GT.NAEZD) THEN
        write(6,*) 'Please, increase the parameter naezd (',naezd,
     +       ') in inc.p to',naez
        STOP 'ERROR in NAEZD.'
      ENDIF
c
      NINEQ = NAEZ
c
      write(6,2104)
c
c
        KAOEZ(1) = 0
c
      IF (KAOEZ(1).eq.0) THEN
        DO I=1,NINEQ
          KAOEZ(I) = I
        END DO
      END IF
c
      OPEN(77,FILE='rbasis',FORM='formatted')
      DO I=1,NAEZ
             READ (UNIT=77,FMT=*) (RBASIS(J,I), J=1,3)
      ENDDO
      CLOSE (77)
c
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      CALL IoInput('RCLUSTZ   ',UIO,IL,7,IER)
              READ (UNIT=UIO,FMT=*) RCUTZ
      CALL IoInput('RCLUSTXY  ',UIO,IL,7,IER)
              READ (UNIT=UIO,FMT=*) RCUTXY
      WRITE(6,*) 'Parameters Used for the cluster calculation'
      if (abs(rcutz-rcutxy).lt.1.d-4) then
      write(6,*) 'Clusters inside spheres with radious R = ',rcutz
      else
      write(6,*) 'Clusters inside cylindels with '
      write(6,*) 'Rz = ',rcutz,' Rxy = ',rcutxy
      end if
      write(6,2018)                 ! rbasis
      write(6,2025) ((rbasis(j,i),j=1,3),i,i=1,naez)
      write(6,2031) ((rbasis(j,i),j=1,3),i,refpot(kaoez(i)),
     +     i=naez+1,naez)

      write(6,2101)
      write(6,2012) (kaoez(i),i=1,naez)
      write(6,2103)
      write(6,2103)
c
      CALL IoInput('BASISCALE ',UIO,IL,7,IER)
                      READ (UNIT=UIO,FMT=*) ABASIS,BBASIS,CBASIS 
      CALL IoInput('ALATBASIS ',UIO,IL,7,IER)
                      READ (UNIT=UIO,FMT=*) ALATC,BLATC,CLATC
      CALL IoInput('BZDIVIDE  ',UIO,IL,7,IER)
                      READ (UNIT=UIO,FMT=*) INTERVX,INTERVY,INTERVZ


c
c
      write(6,2019) abasis,bbasis,cbasis 
      write(6,2104)
      write(6,2014) alatc
      write(6,2107)
      write(6,2015) intervx,intervy,intervz 
      write(6,2102)
c ------------------------------------------------------------------------
      do i=1,nineq
        if (kaoez(i).lt.1) STOP 'Error in KAOEZ'
      enddo
      NCLS = 0
      NREF = 0
      do i=1,nref 
        NTCELLR(I) = 0 
      enddo
c
      DO I=1,NATYP 
        NCLS = MAX(NCLS,CLS(I)) 
      ENDDO
      DO I=1,NATYP 
        NREF = MAX(NREF,REFPOT(I)) 
      ENDDO
      DO I=1,NATYP 
        IF (NTCELLR(REFPOT(I)).EQ.0) NTCELLR(REFPOT(I)) = NTCELL(I)
      ENDDO
c
      WRITE(6,2016) NCLS,NREF,NINEQ
      WRITE(6,2110)
      WRITE(6,2032) (NTCELLR(I),I=1,NREF)
      WRITE(6,2103)

c ------------------------------------------------------------------------

c
c read test options
c
      CALL IoInput('TESTOPT   ',UIO,1,7,IER)
                     READ(UNIT=UIO,FMT=980)(TESTC(i),i=1,8)
      CALL IoInput('TESTOPT   ',UIO,2,7,IER)
                     READ(UNIT=UIO,FMT=980)(TESTC(8+i),i=1,8)
      WRITE(6,52) (TESTC(I),I=1,16)                                                 
 52   FORMAT(79('-')/' TEST OPTIONS:'/2(1X,A8,7('//',A8)/)/79('-'))
c
c
      CALL IoInput('RUNOPT    ',UIO,1,7,IER)
                   READ (UNIT=UIO,FMT=980)(OPTC(i),i=1,8)
      WRITE(6,62) (OPTC(i),i=1,8)                                              
 62   FORMAT(79('-')/' EXECUTION OPTIONS:'/1X,A8,7('//',A8)/79('-'))
 980  FORMAT(8A8)
c
      IL=1
      CALL IoInput('FILES     ',UIO,IL,7,IER)
                      READ (UNIT=UIO,FMT='(A40)')  I12
      CALL IoInput('FILES     ',UIO,IL+1,7,IER)
                      READ (UNIT=UIO,FMT='(A40)')  I13
      CALL IoInput('FILES     ',UIO,IL+2,7,IER)
                      READ (UNIT=UIO,FMT='(A40)')  I40
      CALL IoInput('FILES     ',UIO,IL+3,7,IER)
                      READ (UNIT=UIO,FMT='(A40)')  I19
      CALL IoInput('FILES     ',UIO,IL+4,7,IER)
                      READ (UNIT=UIO,FMT='(A40)')  I25
c
      write(6,*) 'I12="',I12,'"'
      write(6,*) 'I13="',I13,'"'
      write(6,*) 'I40="',I40,'"'
      write(6,*) 'I19="',I19,'"'
      write(6,*) 'I25="',I25,'"'
c
      WRITE(6,2110)
c
      WRITE(6,*) ' >>>>>>>>> RINPUT99 EXITS NOW <<<<<<<<<< '

      RETURN
C *********************************************Input-End ********
 1000 FORMAT(10I4)
 1001 FORMAT(3F12.9)
 1002 FORMAT(80A1)
 1003 FORMAT(10L4)
 1004 FORMAT(I4)
 1005 FORMAT(4I4)
 1006 FORMAT(3F12.9,I4)
 1029 FORMAT((F4.0,I4,4x,4I1,3I4,F8.4,I4,2F8.4))
C ------------------------------------------------------------------------
 2001 FORMAT(/,' ATOM',I3/)
 2002 FORMAT(/,1X,80(A1)///' INPUT DATA :  (NBG=1: LDA; NBG=2: LSDA)')
 2004 FORMAT( 79(1H=)/
     +     'I',77X,'I'/
     +     'I',4X,' Screened Korringa-Kohn-Rostoker ',
     +             'Electronic Structure Code',10X,'I'/
     &     'I',4X,'for Bulk and Interfaces',20X,'I'/
     +     'I',77X,'I',/,'I',4X,'        ',A8,57X,'I'/
     +     'I',77X,'I',/,'I',4X,'Version ',A8,57X,'I'/
     +     'I',77X,'I'/
     +     'I',77X,'I',/,79(1H=),/,/,1X,80A1 )
 2010 FORMAT(' NSPIN '/I4)
 2011 FORMAT(' NSTEPS'/I4)
 2012 FORMAT(' KAOEZ '/,(10I4))
 2013 FORMAT('      M2    MMIN    MMAX    SINN',
     +       '    SOUT     RIN    ROUT'/7I8)
 2014 FORMAT('        ALATC        '/F15.8)
 2015 FORMAT('   INTERVX   INTERVY   INTERVZ'/3I10)
 2016 FORMAT('    NCLS    NREF   NINEQ'/,3I8)
 2018 FORMAT(' RBASIS')
 2019 FORMAT('         ABASIS         BBASIS         CBASIS'/3F15.8)
 2021 FORMAT(' INIPOL'/,(10I4))
 2022 FORMAT(' IXIPOL'/,(10I4))
 2025 FORMAT((3F15.8,I6))
 2026 FORMAT(' COFINV'/,3F15.8)
 2027 FORMAT(' LATT  '/,I4)
 2028 FORMAT
     &(' NATYP '/,I4/,'   Z lmx     KFG cls pot ntc  MTFAC irns   MT  
     &    Size')
 2029 FORMAT(' KMT   '/,I4)
 2031 FORMAT((3F15.8,2I6))
 2032 FORMAT(' NTCELLR'/,(10I4))
 2040 FORMAT('  IFULLD  ISPARD  ISLABD'/,4I8)
 2050 FORMAT(' Dimension and Input Data CHECK')
C ------------------------------------------------------------------------
 2100 FORMAT(79(1H-))
 2101 format(   3(1H-),1H+  , 3(14(1H-),1H+),  30(1H-))
 2102 format( 3(9(1H-),1H+) ,49(1H-))
 2103 FORMAT(10(3(1H-),1H+) ,39(1H-))
 2104 format(   3(1H-),1H+  ,75(1H-))
 2105 format( 3(3(1H-),1H+) ,67(1H-))
 2106 format( 5(3(1H-),1H+) ,59(1H-))
 2107 format( 3(14(1H-),1H+),34(1H-))
 2108 format( 2(3(1H-),1H+),  7(1H-),1H+,      3(3(1H-),1H+),
     +          7(1H-),1H+,   3(1H-),1H+,      39(1H-))
 2109 format( 5(7(1H-),1H+) ,39(1H-))
 2110 format( 3(7(1H-),1H+) ,55(1H-))
 2111 format( 7(7(1H-),1H+) ,23(1H-))
 2112 format( 2(7(1H-),1H+) ,63(1H-))
 9000 FORMAT (I2,3X,4I5)
 9010 FORMAT (1X,I1,1X,4I1)
 9020 FORMAT (/,33x,'check of dimension-data consistency',/,33x,
     +       35 ('-'),/,40x,'lmax   : (',i6,',',i6,')',/,40x,
     +       'natyp  : (',i6,',',i6,')',/,40x,'irm    : (',i6,',',i6,
     +       ')',/,40x,'nspin  : (',i6,',',i6,')',/)
 9030 FORMAT (1x,10 ('*'),' external magnetic field applied hfield=',
     +       f8.5)
 9040 FORMAT (3f12.7)
 9050 FORMAT (20x,a4,'spin polarized calculation')
 9060 FORMAT (8i4)
 9070 FORMAT (1x,20x,' calculation with',a8,'-potential')
 9080 FORMAT (1x,79 ('*'))
 9090 FORMAT (' mixing factor used           :',f15.6,/,
     +        ' convergence quality required :',1p,d15.2)
 9100 FORMAT (1x,20x,a24,'exchange-correlation potential')
 9110 FORMAT (/,20x,'broyden"s method # :',i3,
     +       ' is used up to iteration-      ',/,20x,'depth :',i3,
     +       '  then jacobian is fixed and potential      ',/,20x,
     +       'is updated using that jacobian')
 9120 FORMAT (13x,' in case of calculating non - spherical wavefcts ',
     +       'the parameter lmaxd has to be set equal lmax ! ')
 9130 FORMAT (/)
 9140 FORMAT (20x,'full potential calculation ',
     +       '- cut off of non spherical potential',/,' >',/)
 9150 FORMAT (31x,'representive atom no.',i3,' irns :',i5,' irnsd :',i5)
 9160 FORMAT (21x,a43,/,21x,' using',i3,'-th. born approximation ')
 9170 FORMAT (21x,a43)
 9180 FORMAT (2i5)
 9190 FORMAT (3f12.7,/,4i4)
 9200 FORMAT (3i4,1f12.7)
 9210 FORMAT (' lmax'/,i4)
 9220 FORMAT ('          E1          E2          TK'/,3f12.6)
 9230 FORMAT ('   NPOL  NPNT1  NPNT2  NPNT3'/,4i7)
 9240 FORMAT (' IRNUMX ITCCOR IPRCOR'/,3i7)
 9250 FORMAT ('  IFILE    ISHIFT ESHIFT'/,2i7,f12.6)
 9260 FORMAT (' KSHAPE    IRM    INS   INSREF'/,5i7)
 9280 FORMAT (' external magnetic hfield     :',f15.4/,
     +        ' VCONST                       :',f15.6)
 9290 FORMAT ('   IMIX IPOTOU    ICC'/,4i7)
 9301 format(   3(1H-),1H+  ,75(1H-))
 9302 format( 3(11(1H-),1H+),43(1H-))
 9303 format(3(6(1H-),1H+) ,58(1H-))
 9304 format(4(6(1H-),1H+) ,51(1H-))
 9305 format(3(6(1H-),1H+),11(1H-),1H+ ,46(1H-))
 9306 format(6(6(1H-),1H+) ,37(1H-))
 9307 format(6(1H-),1H+,72(1H-))
 9308 format(11(1H-),1H+,67(1H-))
 9309 format(5(6(1H-),1H+) ,44(1H-))
C
      END





