      SUBROUTINE VISUAL(
     >                  NAEZ,Z,RBASIS,
     >                  IDSHAPE,NFACECL,
     >                  NEDGECL,XEDGECL,YEDGECL,ZEDGECL)
C     ..
C     .. Parameters ..
      include 'inc.geometry'
      INTEGER   NFACED,NVERTD
      PARAMETER (NVERTD=250,NFACED=300)
C     ..
C     .. Scalar Arguments ..
      INTEGER NAEZ
C     ..
C     .. Array Arguments ..
      REAL*8  Z(NAEZD),
     +        RBASIS(3,NAEZD),        ! pos. of atoms in atomic units
     +        XEDGECL(NVERTD,NFACED,NAEZD),
     +        YEDGECL(NVERTD,NFACED,NAEZD),
     +        ZEDGECL(NVERTD,NFACED,NAEZD)
      INTEGER IDSHAPE(NATYPD),
     +        NFACECL(NAEZD),
     +        NEDGECL(NFACED,NAEZD)
C     ..
C     .. Local Scalars ..
      REAL*8  RX,RY,RZ,
     +        CRAD
      INTEGER IAT,ICL,NFACE,NA,
     +        I,J
      LOGICAL EDGES,NUCLEI
C     ..
C     .. Local Arrays ..
      REAL*8  XEDGE(NVERTD,NFACED),
     +        YEDGE(NVERTD,NFACED),
     +        ZEDGE(NVERTD,NFACED),
     +        COLOR(3,0:99),DUMMY(0:99)
      INTEGER NEDGE(NFACED)
C     ..
C=======================================================================
C=======================================================================
C
C should the nuclei be visualized?
      NUCLEI= .TRUE.
C should the edges of the voronoi-construction be visualized?
      EDGES = .TRUE.
C
C=======================================================================
C=======================================================================
C
C
       OPEN(77,FILE='colors',FORM='formatted')
       DO I=1,99
       READ (UNIT=77,FMT=*)    DUMMY(I),COLOR(1,I),COLOR(2,I),COLOR(3,I)
       ENDDO
       COLOR(1,0) = 0.95
       COLOR(2,0) = 0.95
       COLOR(3,0) = 0.95
       CLOSE (77)
C
C
       WRITE (6,*)
       WRITE(6,'(79(1H=),/,15X,A)')
     &     'maindriver: VISUALIZATION, begin'
       WRITE (6,'(79(1H=),/)')
       WRITE (6,*)
C
       OPEN(UNIT=12,STATUS='UNKNOWN',FILE='VORONOI.pov')
       WRITE(12,201)
c
C
C=======================================================================
      DO IAT = 1, NAEZ
C=======================================================================
c
         ICL   = IDSHAPE(IAT)     !CLS(IAT)
         WRITE(*,*) ICL,IAT,NFACECL(ICL)
         RX    = RBASIS(1,IAT)
         RY    = RBASIS(2,IAT)
         RZ    = RBASIS(3,IAT)
         NFACE = NFACECL(ICL) 


         IF (NUCLEI) THEN
         WRITE(12,103) RX,RY,RZ,(0.01+SQRT(Z(IAT)/10.0)/10.0)
         WRITE(12,104) COLOR(1,INT(Z(IAT))),COLOR(2,INT(Z(IAT))),
     &                 COLOR(3,INT(Z(IAT))),0.2
         ENDIF

c
C     The equation        A1*x + A2*y + A3*z = A4
c     is transformed to   A1*x'+ A2*y'+ A3*z'= A4 -(A1*dx+A2*dy+A3dz)
c
c     A4 = A4 - A1*NEW0(1) - A2*NEW0(2) - A3* NEW0(3)
c
         DO I=1,NFACE
           NEDGE(I) = NEDGECL(I,ICL)
           DO J=1,NEDGE(I)
             XEDGE(J,I) = (XEDGECL(J,I,ICL) + RX)
             YEDGE(J,I) = (YEDGECL(J,I,ICL) + RY)
             ZEDGE(J,I) = (ZEDGECL(J,I,ICL) + RZ)
           ENDDO
         ENDDO

         DO I=1,NFACE
           WRITE(12,99) NEDGE(I)+1
           DO J=1,NEDGE(I)
             WRITE(12,100) XEDGE(J,I),YEDGE(J,I),ZEDGE(J,I)
           ENDDO
           WRITE(12,101) XEDGE(1,I),YEDGE(1,I),ZEDGE(1,I)
           WRITE(12,102) COLOR(1,INT(Z(IAT))),COLOR(2,INT(Z(IAT))),
     &                   COLOR(3,INT(Z(IAT))),0.2
         ENDDO

         CRAD = 0.01D0
         DO I=1,NFACE
           NA = NEDGE(I)
           IF (EDGES) THEN
             DO J=1,NA-1
               WRITE(12,500)
               WRITE(12,100) XEDGE(J,I),YEDGE(J,I),ZEDGE(J,I)
               WRITE(12,100) XEDGE(J+1,I),YEDGE(J+1,I),ZEDGE(J+1,I)
               WRITE(12,502) CRAD
               WRITE(12,503) COLOR(1,INT(Z(IAT))),COLOR(2,INT(Z(IAT))),
     &                       COLOR(3,INT(Z(IAT))),0.2
             ENDDO
           ENDIF
           WRITE(12,500)
           WRITE(12,100) XEDGE(NA,I),YEDGE(NA,I),ZEDGE(NA,I)
           WRITE(12,100) XEDGE(1,I),YEDGE(1,I),ZEDGE(1,I)
           WRITE(12,502) CRAD
           WRITE(12,503) COLOR(1,INT(Z(IAT))),COLOR(2,INT(Z(IAT))),
     &                   COLOR(3,INT(Z(IAT))),0.2
         ENDDO

C=======================================================================
       ENDDO
C=======================================================================

       WRITE(12,200)
       WRITE(12,202) -100.0,-100.0,-100.0
       WRITE(12,202) -100.0,-100.0,+100.0
       WRITE(12,202) -100.0,+100.0,-100.0
       WRITE(12,202) -100.0,+100.0,+100.0
       WRITE(12,202) +100.0,-100.0,-100.0
       WRITE(12,202) +100.0,-100.0,+100.0
       WRITE(12,202) +100.0,+100.0,-100.0
       WRITE(12,202) +100.0,+100.0,+100.0


       WRITE (6,*)
       WRITE(6,'(79(1H=),/,15X,A)')
     &     'maindriver: VISUALIZATION, end'
       WRITE (6,'(79(1H=),/)')
       WRITE (6,*)
C
C=======================================================================
C=======================================================================
C
C
c     -------------------------------------------------------
 500     format('cylinder { ')
 502     format(F10.5)
 503     format(' texture { pigment { color rgb <',F10.5,
     &    ',',F10.5,',',F10.5,'> transmit ',F10.5,'}}}')

 99      format('polygon { ' /
     &        I5, ',')
 100     format('< ',F10.5,',',F10.5,',',F10.5,' > ,')
 101     format('< ',F10.5,',',F10.5,',',F10.5,' > ')
 102     format('pigment { color rgb <',F10.5,',',F10.5,',',F10.5,
     &    '> transmit ',F10.5,'} }')

 103     format('sphere{< ',F10.5,',',F10.5,',',F10.5,' > ',F10.5,' ')
 104     format('pigment { color rgb <',F10.5,',',F10.5,',',F10.5,
     &    '> transmit ',F10.5,'} }')

 200     format('camera {' /
     &        '   location < 4, 3, 2 > ' /
     &        '   look_at < 0, 0, 1 > }')
 201     format('#include "colors.inc" ' /
     &        ' background {color White }')
 202  format('light_source{<',F10.5,',',F10.5,
     &         ',',F10.5,'> color White }')

      END


