      SUBROUTINE WRLDOS(DEN,EZ,WEZ,LMAXD1,IEMXD,NPOTD,ITITLE,EFERMI,E1,
     +                  E2,ALATC,TK,NSPIN,NAEZ,IELAST,I1,DOSTOT)

C     .. Parameters ..
      DOUBLE PRECISION KB
      PARAMETER       (KB=0.6333659D-5)
C     ..
C     .. Scalar Arguments ..
      DOUBLE PRECISION ALATC,E1,E2,EFERMI,TK
      INTEGER          IELAST,IEMXD,LMAXD1,
     +                 NAEZ,NPOTD
      INTEGER          NSPIN
C     ..
C     .. Array Arguments ..
      DOUBLE COMPLEX   DEN(0:LMAXD1,IEMXD,NSPIN),
     +                 EZ(IEMXD),WEZ(IEMXD),
     +                 DENIE(3),
     +                 PDEN(0:LMAXD1)
      DOUBLE PRECISION DOSTOT(0:LMAXD1,2),
     +                 PDOSTOT(0:LMAXD1,2)
      INTEGER          ITITLE(20,NPOTD)
C     ..
C     .. Local Scalars ..
      DOUBLE COMPLEX   DOSCMPLX
      DOUBLE PRECISION DOS,DOSSGN,EFCTOR,PI,
     +                 DEREAL,DEIMAG,EREAL
      INTEGER          I1,IA,IE,IPOT,ISPIN,L,D1,D10,D100,D1000,OFF(3)
      CHARACTER*12     FNAME
      LOGICAL          WPDOS
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ATAN,DBLE,DIMAG
C     ..
C     .. External Functions ..
      LOGICAL TEST
      EXTERNAL TEST
C     ..
      PI = 4.0D0*ATAN(1.0D0)
      EFCTOR = 1.0D0
      IF (TEST('EV      ')) EFCTOR = 13.6058D0
C
C
C
C initialize DOSTOT
C
      DO ISPIN = 1,NSPIN
        DO L = 0,LMAXD1
          DOSTOT(L,ISPIN) = 0.0D0
          PDOSTOT(L,ISPIN) = 0.0D0
        END DO
      END DO
C
C
C open file complex.dos - kept for correspondence to complexdos3.f
C
      IF(I1.EQ.1) THEN
      OPEN (49,FILE='complex.dos',FORM='formatted')
      WRITE (49,*) NAEZ*NSPIN
      WRITE (49,*) IELAST
      WRITE (49,*) LMAXD1
      END IF
C
C
C
C=======================================================================
C write DOS to file DOS.I1.dat - begin
C=======================================================================
C
      D1 = mod(I1,10)
      D10 = int( (mod(I1,100) + 0.5)/10 )
      D100 = int( (mod(I1,1000) + 0.5)/100 )
      D1000 = int( (mod(I1,10000) + 0.5)/1000 )

      OFF(1) = iachar('1')-1
      OFF(2) = iachar('1')-1
      OFF(3) = iachar('1')-1

      IF ( D10.GE.10 ) OFF(1) = iachar('7')
      IF ( D100.GE.100 ) OFF(2) = iachar('7')
      IF ( D1000.GE.1000 ) OFF(3) = iachar('7')
 
      FNAME='DOS.'
     + //achar(D1000+OFF(3))
     + //achar(D100+OFF(2))
     + //achar(D10+OFF(1))
     + //achar(D1+iachar('1')-1)
     + //'.dat'

      OPEN(48,FILE=FNAME,FORM='formatted')
C
        DO ISPIN = 1,NSPIN
            IPOT = NSPIN * (I1-1) + ISPIN
            DOSSGN = 1.0D0
            IF (ISPIN.NE.NSPIN) DOSSGN = -1.0D0
C
            WRITE (48,FMT=9010) (ITITLE(IA,IPOT),IA=1,19)
            WRITE (48,FMT=9020) I1
            WRITE (48,FMT=9030) ISPIN,IELAST,E1,E2,EFERMI,EFCTOR
            WRITE (48,FMT=9040) EFERMI
            WRITE (48,FMT=9050) TK,PI*KB*TK,ALATC
C
            DO IE = 1,IELAST
                DOS = 0.0D0
                DO L = 0,LMAXD1
                    DOS = DOS - 2.0D0 *
     &               DIMAG(DEN(L,IE,ISPIN))/PI/DBLE(NSPIN)
                    DOSTOT(L,ISPIN) = DOSTOT(L,ISPIN) +
     +                   DIMAG(WEZ(IE)*DEN(L,IE,ISPIN))
                END DO
                WRITE (48,FMT=9060) DBLE(EZ(IE))*EFCTOR,
     +               (-2.0D0*DIMAG(DEN(L,IE,ISPIN))*DOSSGN/EFCTOR/PI
     &               /DBLE(NSPIN),L=0,LMAXD1),DOS*DOSSGN/EFCTOR
            END DO
C
            WRITE (48,FMT=9070) (DOSTOT(L,ISPIN)/EFCTOR/DBLE(NSPIN),
     +                                                      L=0,LMAXD1)
            IF (ISPIN.NE.NSPIN) WRITE (48,FMT=9000)
        END DO
        CLOSE (48)
C
C=======================================================================
C write DOS to file DOS.I1.dat - end
C=======================================================================
C
C
C=======================================================================
C Write complex DOS to file complex.dos - begin
C=======================================================================
C
        DO ISPIN = 1,NSPIN
            IPOT = NSPIN * (I1-1) + ISPIN
            DOSSGN = 1.0D0
            IF (ISPIN.NE.NSPIN) DOSSGN = -1.0D0
C
            WRITE (49,FMT=9010) (ITITLE(IA,IPOT),IA=1,19)
            WRITE (49,FMT=9020) I1
            WRITE (49,FMT=9030) ISPIN,IELAST,E1,E2,EFERMI,EFCTOR
            WRITE (49,FMT=9040) EFERMI
            WRITE (49,FMT=9050) TK,PI*KB*TK,ALATC
C
            DO IE = 1,IELAST
                DOSCMPLX = DCMPLX(0.0D0,0.D0)
                DO L = 0,LMAXD1
                    DOSCMPLX = DOSCMPLX - 2.0D0 *
     &               DEN(L,IE,ISPIN)/PI/DBLE(NSPIN)
                END DO
                WRITE (49,FMT=9065) EZ(IE)*EFCTOR,
     +               (-2.0D0*DEN(L,IE,ISPIN)*DOSSGN/EFCTOR/PI
     &               /DBLE(NSPIN),L=0,LMAXD1),DOSCMPLX*DOSSGN/EFCTOR
            END DO
C
            IF (ISPIN.NE.NSPIN.OR.I1.NE.NAEZ) WRITE (49,FMT=9000)
        END DO
      IF(I1.EQ.NAEZ) CLOSE (49)
C
C=======================================================================
C Write complex DOS to file complex.dos - begin
C=======================================================================
C
C
C
C=======================================================================
C Write projected DOS to file PDOS.I1.dat - begin
C=======================================================================
C
C adapted from program complexdos3.f:
C "Principle of DOS here: Two-point contour integration
C  for DOS in the middle of the two points. The input DOS
C  and energy must be complex. Parameter DEREAL should be
C  of the order of magnitude of DEIMAG."
C
C
      WPDOS = .FALSE.
C
      IF (WPDOS) THEN
C
        FNAME='PDOS.'
     +   //achar(D1000+OFF(3))
     +   //achar(D100+OFF(2))
     +   //achar(D10+OFF(1))
     +   //achar(D1+iachar('1')-1)
     +   //'.dat'
C
        OPEN(48,FILE=FNAME,FORM='formatted')
C
          DO ISPIN = 1,NSPIN
            IPOT = NSPIN * (I1-1) + ISPIN
            DOSSGN = 1.0D0
            IF (ISPIN.NE.NSPIN) DOSSGN = -1.0D0
C
            WRITE (48,FMT=9010) (ITITLE(IA,IPOT),IA=1,19)
            WRITE (48,FMT=9020) I1
            WRITE (48,FMT=9030) ISPIN,IELAST,E1,E2,EFERMI,EFCTOR
            WRITE (48,FMT=9040) EFERMI
            WRITE (48,FMT=9050) TK,PI*KB*TK,ALATC
C
            DO IE = 1,IELAST
C
                DEREAL = DREAL(EZ(IE+1) - EZ(IE))
                DEIMAG = DIMAG(EZ(IE))
                EREAL   = DREAL(EZ(IE))
C
                DOSCMPLX = DCMPLX(0.0D0,0.D0)
C
                DO L = 0,LMAXD1
C
                  DENIE(1) =
     & -2.0D0*DEN(L,IE-1,ISPIN)*DOSSGN/EFCTOR/PI/DBLE(NSPIN)
                  DENIE(2) =
     & -2.0D0*DEN(L,IE,ISPIN)*DOSSGN/EFCTOR/PI/DBLE(NSPIN)
                  DENIE(3) =
     & -2.0D0*DEN(L,IE+1,ISPIN)*DOSSGN/EFCTOR/PI/DBLE(NSPIN)
C
                  PDEN(L) = DENIE(2)
     &            +0.5d0*(DENIE(1)-DENIE(3))*DCMPLX(0.d0,DEIMAG)/DEREAL
C
                  DOSCMPLX = DOSCMPLX + PDEN(L)
C
                  PDOSTOT(L,ISPIN) = PDOSTOT(L,ISPIN) +
     +                   DIMAG(WEZ(IE)*PDEN(L))
C
                ENDDO
C
                WRITE (48,FMT=9060) EREAL,
     +               (DIMAG(PDEN(L)),L=0,LMAXD1-1),DOSCOMPLX


            END DO
C
            WRITE (48,FMT=9070) (PDOSTOT(L,ISPIN)/EFCTOR/DBLE(NSPIN),
     +                           L=0,LMAXD1)
C
            IF (ISPIN.NE.NSPIN) WRITE (48,FMT=9000)
C
        END DO
C
        CLOSE (48)
C
      ENDIF
C
C=======================================================================
C Write projected DOS to file PDOS.I1.dat - begin
C=======================================================================
C
C
      RETURN
C
 9000 FORMAT ('&')
 9010 FORMAT ('#',19a4)
 9020 FORMAT ('# I1    :',I8)
 9030 FORMAT ('# ISPIN :',I8,'   IELAST :',I5,/,'# E1,E2 :',2f12.5,
     +       ' EFERMI :',f12.5,'   EFCTR',f10.6)
 9040 FORMAT ('# FERMI :',f12.5)
 9050 FORMAT ('# TK    =',f8.1,'   Kelvin =',3p,f8.3,' mRyd',0p,/,
     +       '# ALAT   :',f12.5)
 9060 FORMAT (1p,8e15.7)
 9065 FORMAT (1p,16d15.7)
 9070 FORMAT ('# Integrated DOS ',1p,d10.3,7d11.3)
 9080 FORMAT ('&')
      END
