!      SUBROUTINE ZGEMV_OPT(M,N,A,TGMOPT,X,Y,K,IE)
      SUBROUTINE ZGEMV_OPT(M,N,A,X,Y)
*     .. Scalar Arguments ..
      INTEGER M,N
*     ..
*     .. Array Arguments ..
      DOUBLE COMPLEX A(M,N),X(N),Y(M),YM(1,M)
*     ..
*
*  Purpose
*  =======
*
*  ZGEMV  performs one of the matrix-vector operations
*
*     y := A*x + y
*
*  where alpha and beta are scalars, x and y are vectors and A is an
*  m by n matrix.
*
*  Arguments
*  ==========
*
*  M      - INTEGER.
*           On entry, M specifies the number of rows of the matrix A.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of the matrix A.
*           Unchanged on exit.
*
*  A      - COMPLEX*16       array of DIMENSION ( M, N ).
*           Before entry, the leading m by n part of the array A must
*           contain the matrix of coefficients.
*           Unchanged on exit.
*
*  X      - COMPLEX*16       array of DIMENSION N
*           Before entry, the incremented array X must contain the
*           vector x.
*           Unchanged on exit.
*
*  Y      - COMPLEX*16       array of DIMENSION M
*           Before entry with BETA non-zero, the incremented array Y
*           must contain the vector y. On exit, Y is overwritten by the
*           updated vector y.
*
*     .. Parameters ..
      DOUBLE COMPLEX ZERO
      PARAMETER (ZERO= (0.0D+0,0.0D+0))
*     ..
*     .. Local Scalars ..
      DOUBLE COMPLEX TEMP
      INTEGER I,IY,J
*     ..
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
*        Form  y := alpha*A*x + y.
*
        DO I = 1,M
        YM(1,I) = Y(I)
        ENDDO

         DO 60 J = 1,N
           IF (X(J).NE.ZERO) THEN
              TEMP = X(J)
             DO 50 I = 1,M
               YM(1,I) = YM(1,I) + TEMP*A(I,J)
C               Y(I) = Y(I) + TEMP*A(I,J)
   50        CONTINUE
           END IF
   60    CONTINUE
*
        DO I = 1,M
        Y(I) = YM(1,I)
        ENDDO
*
      RETURN
*
*     End of ZGEMV .
*
      END
